
;CodeVisionAVR C Compiler V2.04.9a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATxmega64A1
;Program type             : Application
;Clock frequency          : 32.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : long, width
;(s)scanf features        : long, width
;External RAM size        : 0
;Data Stack size          : 1024 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : No
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATxmega64A1
	#pragma AVRPART MEMORY PROG_FLASH 67584
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x2000

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU CCP=0x34
	.EQU RAMPD=0x38
	.EQU RAMPX=0x39
	.EQU RAMPY=0x3A
	.EQU RAMPZ=0x3B
	.EQU EIND=0x3C
	.EQU WDT_CTRL=0x80
	.EQU PMIC_CTRL=0xA2
	.EQU NVM_ADDR0=0X01C0
	.EQU NVM_ADDR1=NVM_ADDR0+1
	.EQU NVM_ADDR2=NVM_ADDR1+1
	.EQU NVM_DATA0=NVM_ADDR0+4
	.EQU NVM_CMD=NVM_ADDR0+0xA
	.EQU NVM_CTRLA=NVM_ADDR0+0xB
	.EQU NVM_CTRLB=NVM_ADDR0+0xC
	.EQU NVM_STATUS=NVM_ADDR0+0xF
	.EQU PORTCFG_MPCMASK=0xB0
	.EQU PORTH_DIR=0x6E0
	.EQU PORTH_OUT=0x6E4
	.EQU PORTH_PIN0CTRL=0x6F0
	.EQU PORTJ_DIR=0x700
	.EQU PORTJ_OUT=0x704
	.EQU PORTJ_PIN0CTRL=0x710
	.EQU PORTK_DIR=0x720
	.EQU PORTK_OUT=0x724
	.EQU PORTK_PIN0CTRL=0x730
	.EQU EBI_CTRL=0x0440
	.EQU EBI_SDRAMCTRLA=EBI_CTRL+1
	.EQU EBI_REFRESHL=EBI_CTRL+4
	.EQU EBI_REFRESHH=EBI_CTRL+5
	.EQU EBI_INITDLYL=EBI_CTRL+6
	.EQU EBI_INITDLYH=EBI_CTRL+7
	.EQU EBI_SDRAMCTRLB=EBI_CTRL+8
	.EQU EBI_SDRAMCTRLC=EBI_CTRL+9
	.EQU EBI_CS0_CTRLA=EBI_CTRL+0x10
	.EQU EBI_CS0_CTRLB=EBI_CS0_CTRLA+1
	.EQU EBI_CS0_BASEADDRL=EBI_CS0_CTRLA+2
	.EQU EBI_CS0_BASEADDRH=EBI_CS0_CTRLA+3
	.EQU EBI_CS1_CTRLA=EBI_CTRL+0x14
	.EQU EBI_CS1_CTRLB=EBI_CS1_CTRLA+1
	.EQU EBI_CS1_BASEADDRL=EBI_CS1_CTRLA+2
	.EQU EBI_CS1_BASEADDRH=EBI_CS1_CTRLA+3
	.EQU EBI_CS2_CTRLA=EBI_CTRL+0x18
	.EQU EBI_CS2_CTRLB=EBI_CS2_CTRLA+1
	.EQU EBI_CS2_BASEADDRL=EBI_CS2_CTRLA+2
	.EQU EBI_CS2_BASEADDRH=EBI_CS2_CTRLA+3
	.EQU EBI_CS3_CTRLA=EBI_CTRL+0x1C
	.EQU EBI_CS3_CTRLB=EBI_CS3_CTRLA+1
	.EQU EBI_CS3_BASEADDRL=EBI_CS3_CTRLA+2
	.EQU EBI_CS3_BASEADDRH=EBI_CS3_CTRLA+3
	.EQU EBI_SDCAS_bp=3
	.EQU EBI_SDROW_bp=2
	.EQU EBI_SDCOL_bp=0
	.EQU EBI_MRDLY_bp=6
	.EQU EBI_ROWCYCDLY_bp=3
	.EQU EBI_RPDLY_bp=0
	.EQU EBI_WRDLY_bp=6
	.EQU EBI_ESRDLY_bp=3
	.EQU EBI_ROWCOLDLY_bp=0
	.EQU EBI_CS_ASPACE_256B_gc=0x00<<2
	.EQU EBI_CS_ASPACE_512B_gc=0x01<<2
	.EQU EBI_CS_ASPACE_1KB_gc=0x02<<2
	.EQU EBI_CS_ASPACE_2KB_gc=0x03<<2
	.EQU EBI_CS_ASPACE_4KB_gc=0x04<<2
	.EQU EBI_CS_ASPACE_8KB_gc=0x05<<2
	.EQU EBI_CS_ASPACE_16KB_gc=0x06<<2
	.EQU EBI_CS_ASPACE_32KB_gc=0x07<<2
	.EQU EBI_CS_ASPACE_64KB_gc=0x08<<2
	.EQU EBI_CS_ASPACE_128KB_gc=0x09<<2
	.EQU EBI_CS_ASPACE_256KB_gc=0x0A<<2
	.EQU EBI_CS_ASPACE_512KB_gc=0x0B<<2
	.EQU EBI_CS_ASPACE_1MB_gc=0x0C<<2
	.EQU EBI_CS_ASPACE_2MB_gc=0x0D<<2
	.EQU EBI_CS_ASPACE_4MB_gc=0x0E<<2
	.EQU EBI_CS_ASPACE_8MB_gc=0x0F<<2
	.EQU EBI_CS_ASPACE_16M_gc=0x10<<2
	.EQU EBI_CS_MODE_DISABLED_gc=0x00
	.EQU EBI_CS_MODE_SRAM_gc=0x01
	.EQU EBI_CS_MODE_LPC_gc=0x02
	.EQU EBI_CS_MODE_SDRAM_gc=0x03
	.EQU EBI_SDDATAW_4BIT_gc=0x00<<6
	.EQU EBI_SDDATAW_8BIT_gc=0x01<<6
	.EQU EBI_LPCMODE_ALE1_gc=0x00<<4
	.EQU EBI_LPCMODE_ALE12_gc=0x02<<4
	.EQU EBI_SRMODE_ALE1_gc=0x00<<2
	.EQU EBI_SRMODE_ALE2_gc=0x01<<2
	.EQU EBI_SRMODE_ALE12_gc=0x02<<2
	.EQU EBI_SRMODE_NOALE_gc=0x03<<2
	.EQU EBI_IFMODE_DISABLED_gc=0x00
	.EQU EBI_IFMODE_3PORT_gc=0x01
	.EQU EBI_IFMODE_4PORT_gc=0x02
	.EQU EBI_IFMODE_2PORT_gc=0x03
	.EQU EBI_SDCOL_8BIT_gc=0x00
	.EQU EBI_SDCOL_9BIT_gc=0x01
	.EQU EBI_SDCOL_10BIT_gc=0x02
	.EQU EBI_SDCOL_11BIT_gc=0x03
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIO0=0x00
	.EQU GPIO1=0x01
	.EQU GPIO2=0x02
	.EQU GPIO3=0x03
	.EQU GPIO4=0x04
	.EQU GPIO5=0x05
	.EQU GPIO6=0x06
	.EQU GPIO7=0x07
	.EQU GPIO8=0x08
	.EQU GPIO9=0x09
	.EQU GPIO10=0x0A
	.EQU GPIO11=0x0B
	.EQU GPIO12=0x0C
	.EQU GPIO13=0x0D
	.EQU GPIO14=0x0E
	.EQU GPIO15=0x0F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x2000
	.EQU __SRAM_END=0x2FFF
	.EQU __DSTACK_SIZE=0x0400
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _com7_rx_data=R3
	.DEF _com7_rx_eflg=R2
	.DEF _com8_rx_eflg=R5
	.DEF _com8_rx_usi=R6
	.DEF _com8_rx_udi=R8
	.DEF _timer0_base_cnt=R10
	.DEF _timer0_tx_cnt=R12

;GPIO0-GPIO15 INITIALIZATION VALUES
	.EQU __GPIO0_INIT=0x00
	.EQU __GPIO1_INIT=0x00
	.EQU __GPIO2_INIT=0x00
	.EQU __GPIO3_INIT=0x00
	.EQU __GPIO4_INIT=0x00
	.EQU __GPIO5_INIT=0x00
	.EQU __GPIO6_INIT=0x00
	.EQU __GPIO7_INIT=0x00
	.EQU __GPIO8_INIT=0x00
	.EQU __GPIO9_INIT=0x00
	.EQU __GPIO10_INIT=0x00
	.EQU __GPIO11_INIT=0x00
	.EQU __GPIO12_INIT=0x00
	.EQU __GPIO13_INIT=0x00
	.EQU __GPIO14_INIT=0x00
	.EQU __GPIO15_INIT=0x00

;GLOBAL REGISTER VARIABLES INITIALIZATION VALUES
	.EQU __R2_INIT=0x00
	.EQU __R3_INIT=0x00
	.EQU __R4_INIT=0x00
	.EQU __R5_INIT=0x00
	.EQU __R6_INIT=0x00
	.EQU __R7_INIT=0x00
	.EQU __R8_INIT=0x00
	.EQU __R9_INIT=0x00
	.EQU __R10_INIT=0x00
	.EQU __R11_INIT=0x00
	.EQU __R12_INIT=0x00
	.EQU __R13_INIT=0x00
	.EQU __R14_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _tcc0_overflow_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usartf0_rx_isr
	JMP  0x00
	JMP  0x00
	JMP  _usartf1_rx_isr
	JMP  0x00
	JMP  0x00

_0x80000:
	.DB  0x25,0x30,0x32,0x58,0x0,0x25,0x30,0x34
	.DB  0x64,0x0,0x73,0x65,0x6E,0x64,0x20,0x3A
	.DB  0x20,0x25,0x73,0xD,0xA,0x0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  RAMPD,R30
	OUT  RAMPX,R30
	OUT  RAMPY,R30

;MEMORY MAPPED EEPROM ACCESS IS USED
	LDS  R31,NVM_CTRLB
	ORI  R31,0x08
	STS  NVM_CTRLB,R31

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,0xD8
	OUT  CCP,R31
	STS  PMIC_CTRL,R30

;NO EXTERNAL RAM IS USED
	STS  EBI_CTRL,R30

;DISABLE WATCHDOG
	LDS  R26,WDT_CTRL
	CBR  R26,2
	SBR  R26,1
	OUT  CCP,R31
	STS  WDT_CTRL,R26

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

	OUT  RAMPZ,R24

;GPIO0-GPIO15 INITIALIZATION
	LDI  R30,__GPIO0_INIT
	OUT  GPIO0,R30
	;__GPIO1_INIT = __GPIO0_INIT
	OUT  GPIO1,R30
	;__GPIO2_INIT = __GPIO0_INIT
	OUT  GPIO2,R30
	;__GPIO3_INIT = __GPIO0_INIT
	OUT  GPIO3,R30
	;__GPIO4_INIT = __GPIO0_INIT
	OUT  GPIO4,R30
	;__GPIO5_INIT = __GPIO0_INIT
	OUT  GPIO5,R30
	;__GPIO6_INIT = __GPIO0_INIT
	OUT  GPIO6,R30
	;__GPIO7_INIT = __GPIO0_INIT
	OUT  GPIO7,R30
	;__GPIO8_INIT = __GPIO0_INIT
	OUT  GPIO8,R30
	;__GPIO9_INIT = __GPIO0_INIT
	OUT  GPIO9,R30
	;__GPIO10_INIT = __GPIO0_INIT
	OUT  GPIO10,R30
	;__GPIO11_INIT = __GPIO0_INIT
	OUT  GPIO11,R30
	;__GPIO12_INIT = __GPIO0_INIT
	OUT  GPIO12,R30
	;__GPIO13_INIT = __GPIO0_INIT
	OUT  GPIO13,R30
	;__GPIO14_INIT = __GPIO0_INIT
	OUT  GPIO14,R30
	;__GPIO15_INIT = __GPIO0_INIT
	OUT  GPIO15,R30

;GLOBAL REGISTER VARIABLES INITIALIZATION
	;__R2_INIT = __GPIO0_INIT
	MOV  R2,R30
	;__R3_INIT = __GPIO0_INIT
	MOV  R3,R30
	;__R5_INIT = __GPIO0_INIT
	MOV  R5,R30
	;__R6_INIT = __GPIO0_INIT
	MOV  R6,R30
	;__R7_INIT = __GPIO0_INIT
	MOV  R7,R30
	;__R8_INIT = __GPIO0_INIT
	MOV  R8,R30
	;__R9_INIT = __GPIO0_INIT
	MOV  R9,R30
	;__R10_INIT = __GPIO0_INIT
	MOV  R10,R30
	;__R11_INIT = __GPIO0_INIT
	MOV  R11,R30
	;__R12_INIT = __GPIO0_INIT
	MOV  R12,R30
	;__R13_INIT = __GPIO0_INIT
	MOV  R13,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x2400

	.CSEG
;// ========================= AtxmegaxxxA1 ADC  α׷ ==================
;//  CPU : ATmegaxxxA1
;//     ¥ : 2010-
;//      : Ver1.0
;//    : www.cpuplaza.com
;// Ϸ : CodeVisionAVR 2.04.6
;// ----------------------------------------------------------------------------
;// ⺻ 
;#include <io.h>							// CPU  
;
;#include <stdint.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <ctype.h>
;#include <stdbool.h>
;#include <delay.h>
;
;//  
;#include "adc_drv.h"						// ADC 
;
;// ======================== ADC CalibrationValues Load ========================
;// [μ] ADC_t * adc
;// Item1: ADC Port (ADCA,ADCB)
;// ----------------------------------------------------------------------------
;void ADC_CalibrationValues_Load(ADC_t *adc)
; 0000 001A {

	.CSEG
; 0000 001B 	if(&ADCA == adc){					// Get ADCACAL0 from production signature.
;	*adc -> Y+0
; 0000 001C 		(adc)->CALL = SP_ReadCalibrationByte(PROD_SIGNATURES_START+ADCACAL0_offset );
; 0000 001D 		(adc)->CALH = SP_ReadCalibrationByte(PROD_SIGNATURES_START+ADCACAL1_offset );
; 0000 001E 	}
; 0000 001F 	else{							// Get ADCBCAL0 from production signature
; 0000 0020 		(adc)->CALL = SP_ReadCalibrationByte(PROD_SIGNATURES_START+ADCBCAL0_offset );
; 0000 0021 		(adc)->CALH = SP_ReadCalibrationByte(PROD_SIGNATURES_START+ADCBCAL1_offset );
; 0000 0022 	}
; 0000 0023 }
;
;// ========================= Flash  CAL ε ========================
;// [μ] unsigned char index
;// Item1: NVM address
;// ----------------------------------------------------------------------------
;unsigned char SP_ReadCalibrationByte(unsigned char index)
; 0000 002A {
; 0000 002B unsigned char flash *idx_base = (unsigned char*)0x0;
; 0000 002C unsigned char result;
; 0000 002D 
; 0000 002E 	NVM.CMD = NVM_CMD_READ_CALIB_ROW_gc;			// Load the NVM Command register to read the calibration row.
;	index -> Y+4
;	*idx_base -> R16,R17
;	result -> R19
; 0000 002F 	result = *(idx_base+index);
; 0000 0030 
; 0000 0031 	NVM.CMD = NVM_CMD_NO_OPERATION_gc;			// Clean up NVM Command register.
; 0000 0032 	return result;
; 0000 0033 }
;
;// =============================== ADC_Wait_8MHz ==============================
;// [μ] ADC_t * adc
;// Item1: ADC Port (ADCA,ADCB)
;// ----------------------------------------------------------------------------
;void ADC_Wait_8MHz(ADC_t *adc)
; 0000 003A {
; 0000 003B unsigned char prescaler_val = (adc)->PRESCALER;			// Store old prescaler value.
; 0000 003C 
; 0000 003D 	(adc)->PRESCALER = ADC_PRESCALER_DIV4_gc;		// Set prescaler value to minimum value.
;	*adc -> Y+1
;	prescaler_val -> R17
; 0000 003E 	delay_us(4*COMMON_MODE_CYCLES);			// Wait 4*COMMON_MODE_CYCLES for common mode to settle.
; 0000 003F 	(adc)->PRESCALER = prescaler_val;			// Set prescaler to old value
; 0000 0040 }
;
;// =============================== ADC_Wait_32MHz =============================
;// [μ] ADC_t * adc
;// Item1: ADC Port (ADCA,ADCB)
;// ----------------------------------------------------------------------------
;void ADC_Wait_32MHz(ADC_t *adc)
; 0000 0047 {
; 0000 0048 unsigned char prescaler_val = (adc)->PRESCALER;			// Store old prescaler value.
; 0000 0049 
; 0000 004A 	(adc)->PRESCALER = ADC_PRESCALER_DIV8_gc;		// Set prescaler value to minimum value.
;	*adc -> Y+1
;	prescaler_val -> R17
; 0000 004B 	delay_us(8*COMMON_MODE_CYCLES);			// Wait 8*COMMON_MODE_CYCLES for common mode to settle.
; 0000 004C 	(adc)->PRESCALER = prescaler_val;			// Set prescaler to old value
; 0000 004D }
;
;// ========================== ADC Offset Get Signed ===========================
;// [μ] ADC_CH_t *ch, bool oversampling
;// Item1: ADC CH (ADCA.CH0, ADCA.CH1, ADCA.CH2, ADCA.CH3, ADCB.CH0, ADCB.CH1, ADCB.CH2, ADCB.CH3)
;// Item2: oversampling(false,TRUE)
;// ----------------------------------------------------------------------------
;char ADC_Offset_Get_Signed(ADC_CH_t *ch, bool oversampling)
; 0000 0055 {
; 0000 0056 char offset = 0;
; 0000 0057 int i,offset1 = 0;
; 0000 0058 
; 0000 0059 	if(oversampling){
;	*ch -> Y+7
;	oversampling -> Y+6
;	offset -> R17
;	i -> R18,R19
;	offset1 -> R20,R21
; 0000 005A 		for(i = 0; i < 4; i++){
; 0000 005B 			ADC_Ch_Conversion_Start(ch);		// Do one conversion to find offset.
; 0000 005C 			while(!ADC_Ch_Conversion_Complete(ch));
; 0000 005D 			offset1 += ADC_ResultCh_GetWord_Signed(ch, 0x00);
; 0000 005E 		}
; 0000 005F 		return((char)(offset1 / 4));
; 0000 0060 	}
; 0000 0061 	else{
; 0000 0062 		ADC_Ch_Conversion_Start(ch);			// Do one conversion to find offset.
; 0000 0063 		while(!ADC_Ch_Conversion_Complete(ch));
; 0000 0064 		offset = (char)ADC_ResultCh_GetWord_Signed(ch, 0x00);
; 0000 0065 		return(offset);
; 0000 0066 	}
; 0000 0067 }
;
;// ========================= ADC Offset Get Unsigned ==========================
;// [μ] ADC_CH_t *ch, bool oversampling
;// Item1: ADC CH (ADCA.CH0, ADCA.CH1, ADCA.CH2, ADCA.CH3, ADCB.CH0, ADCB.CH1, ADCB.CH2, ADCB.CH3)
;// Item2: oversampling(false,TRUE)
;// ----------------------------------------------------------------------------
;unsigned char ADC_Offset_Get_Unsigned(ADC_CH_t *ch, bool oversampling)
; 0000 006F {
; 0000 0070 unsigned char offset = 0;
; 0000 0071 int i,offset1 = 0;
; 0000 0072 
; 0000 0073 	if(oversampling){
;	*ch -> Y+7
;	oversampling -> Y+6
;	offset -> R17
;	i -> R18,R19
;	offset1 -> R20,R21
; 0000 0074 		for(i = 0; i < 4; i++){
; 0000 0075 			ADC_Ch_Conversion_Start(ch);		// Do one conversion to find offset.
; 0000 0076 			while(!ADC_Ch_Conversion_Complete(ch));
; 0000 0077 			offset1 += ADC_ResultCh_GetWord_Signed(ch, 0x00);
; 0000 0078 		}
; 0000 0079 		return((unsigned char)(offset1 / 4));
; 0000 007A 	}
; 0000 007B 	else{
; 0000 007C 		ADC_Ch_Conversion_Start(ch);			// Do one conversion to find offset.
; 0000 007D 		while(!ADC_Ch_Conversion_Complete(ch));
; 0000 007E 		offset = (unsigned char)ADC_ResultCh_GetWord_Signed(ch, 0x00);
; 0000 007F 		return(offset);
; 0000 0080 	}
; 0000 0081 }
;
;// ====================== ADC ResultCh GetWord Unsigned =======================
;// [μ] ADC_CH_t *adc_ch, unsigned char offset
;// Item1: ADC CH (ADCA.CH0, ADCA.CH1, ADCA.CH2, ADCA.CH3, ADCB.CH0, ADCB.CH1, ADCB.CH2, ADCB.CH3)
;// Item2: offset 
;// ----------------------------------------------------------------------------
;unsigned int ADC_ResultCh_GetWord_Unsigned(ADC_CH_t *adc_ch, unsigned char offset)
; 0000 0089 {
; 0000 008A unsigned int answer;
; 0000 008B 
; 0000 008C 	(adc_ch)->INTFLAGS = ADC_CH_CHIF_bm;			// Clear interrupt flag
;	*adc_ch -> Y+3
;	offset -> Y+2
;	answer -> R16,R17
; 0000 008D 	answer = (adc_ch)->RES - offset;			// Return result register contents
; 0000 008E 	return(answer);
; 0000 008F }
;
;// ======================= ADC ResultCh GetWord Signed ========================
;// [μ] ADC_CH_t *adc_ch, char signedOffset
;// Item1: ADC CH (ADCA.CH0, ADCA.CH1, ADCA.CH2, ADCA.CH3, ADCB.CH0, ADCB.CH1, ADCB.CH2, ADCB.CH3)
;// Item2: offset 
;// ----------------------------------------------------------------------------
;int16_t ADC_ResultCh_GetWord_Signed(ADC_CH_t *adc_ch, char signedOffset)
; 0000 0097 {
; 0000 0098 int answer;
; 0000 0099 
; 0000 009A 
; 0000 009B 	(adc_ch)->INTFLAGS = ADC_CH_CHIF_bm;			// Clear interrupt flag
;	*adc_ch -> Y+3
;	signedOffset -> Y+2
;	answer -> R16,R17
; 0000 009C 	answer = (adc_ch)->RES - signedOffset;			// Return result register contents
; 0000 009D 	return(answer);
; 0000 009E }
;
;// ========================== ADC ResultCh GetWord ============================
;// [μ] ADC_CH_t *adc_ch
;// Item1: ADC CH (ADCA.CH0, ADCA.CH1, ADCA.CH2, ADCA.CH3, ADCB.CH0, ADCB.CH1, ADCB.CH2, ADCB.CH3)
;// ----------------------------------------------------------------------------
;unsigned int ADC_ResultCh_GetWord(ADC_CH_t *adc_ch)
; 0000 00A5 {
; 0000 00A6 	(adc_ch)->INTFLAGS = ADC_CH_CHIF_bm;			// Clear interrupt flag
;	*adc_ch -> Y+0
; 0000 00A7 	return((adc_ch)->RES);					// Return result register contents
; 0000 00A8 }
;
;// ========================= ADC ResultCh GetHighByte =========================
;// [μ] ADC_CH_t *adc_ch
;// Item1: ADC CH (ADCA.CH0, ADCA.CH1, ADCA.CH2, ADCA.CH3, ADCB.CH0, ADCB.CH1, ADCB.CH2, ADCB.CH3)
;// ----------------------------------------------------------------------------
;unsigned char ADC_ResultCh_GetHighByte(ADC_CH_t *adc_ch)
; 0000 00AF {
; 0000 00B0 	(adc_ch)->INTFLAGS = ADC_CH_CHIF_bm;			// Clear interrupt flag
;	*adc_ch -> Y+0
; 0000 00B1 	return((adc_ch)->RESH);					// Return result register contents
; 0000 00B2 }
;
;// ========================= ADC ResultCh GetLowByte ==========================
;// [μ] ADC_CH_t *adc_ch
;// Item1: ADC CH (ADCA.CH0, ADCA.CH1, ADCA.CH2, ADCA.CH3, ADCB.CH0, ADCB.CH1, ADCB.CH2, ADCB.CH3)
;// ----------------------------------------------------------------------------
;unsigned char ADC_ResultCh_GetLowByte(ADC_CH_t *adc_ch)
; 0000 00B9 {
; 0000 00BA 	(adc_ch)->INTFLAGS = ADC_CH_CHIF_bm;			// Clear interrupt flag
;	*adc_ch -> Y+0
; 0000 00BB 	return((adc_ch)->RESL);					// Return result register contents
; 0000 00BC }
;// ========================= AtxmegaxxxA1 DAC  α׷ ==================
;//  CPU : ATmegaxxxA1
;//     ¥ : 2010-
;//      : Ver1.0
;//    : www.cpuplaza.com
;// Ϸ : CodeVisionAVR 2.04.6
;// ----------------------------------------------------------------------------
;// ⺻ 
;#include <io.h>							// CPU  
;
;#include <stdint.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <ctype.h>
;#include <stdbool.h>
;
;//  
;#include "dac_drv.h"						// DAC 
;
;// ========================= DAC SingleChannel Enable =========================
;// [μ] DAC_t *dac,DAC_REFSEL_t convRef, bool leftAdjust
;// Item1: DAC Port (DACA,DACB)
;// Item2: DAC Reference Selection(DAC_REFSEL_INT1V_gc,DAC_REFSEL_AVCC_gc,DAC_REFSEL_AREFA_gc,DAC_REFSEL_AREFB_gc)
;// Item3: DAC Left-Adjust Value
;// ----------------------------------------------------------------------------
;void DAC_SingleChannel_Enable(DAC_t *dac,DAC_REFSEL_t convRef, bool leftAdjust)
; 0001 001B {

	.CSEG
; 0001 001C 	(dac)->CTRLB = ((dac)->CTRLB & ~DAC_CHSEL_gm ) | DAC_CHSEL_SINGLE_gc;
;	*dac -> Y+2
;	convRef -> Y+1
;	leftAdjust -> Y+0
; 0001 001D 	(dac)->CTRLC = ((dac)->CTRLC & ~(DAC_REFSEL_gm | DAC_LEFTADJ_bm) ) | convRef | ( leftAdjust ? DAC_LEFTADJ_bm : 0x00 );
; 0001 001E 	(dac)->CTRLA = ((dac)->CTRLA & ~DAC_CH1EN_bm ) | DAC_CH0EN_bm | DAC_ENABLE_bm;
; 0001 001F }
;
;// ============================ DAC_DualChannel_Enable =========================
;// [μ] DAC_t *dac, DAC_REFSEL_t convRef,bool leftAdjust,DAC_CONINTVAL_t sampleInterval,DAC_REFRESH_t refreshInterval
;// Item1: DAC Port (DACA,DACB)
;// Item2: DAC Reference Selection(DAC_REFSEL_INT1V_gc,DAC_REFSEL_AVCC_gc,DAC_REFSEL_AREFA_gc,DAC_REFSEL_AREFB_gc)
;// Item3: DAC Left-Adjust Value
;// Item4: DAC Timing Control Register(DAC_CONINTVAL_1CLK_gc,DAC_CONINTVAL_2CLK_gc,DAC_CONINTVAL_4CLK_gc,DAC_CONINTVAL_8CLK_gc
;//                                    DAC_CONINTVAL_16CLK_gc,DAC_CONINTVAL_32CLK_gc,DAC_CONINTVAL_64CLK_gc,DAC_CONINTVAL_128CLK_gc
;// ----------------------------------------------------------------------------
;void DAC_DualChannel_Enable(DAC_t *dac, DAC_REFSEL_t convRef,bool leftAdjust,DAC_CONINTVAL_t sampleInterval,DAC_REFRESH_t refreshInterval)
; 0001 002A {
; 0001 002B 	(dac)->CTRLB = ((dac)->CTRLB & ~DAC_CHSEL_gm ) | DAC_CHSEL_DUAL_gc;
;	*dac -> Y+4
;	convRef -> Y+3
;	leftAdjust -> Y+2
;	sampleInterval -> Y+1
;	refreshInterval -> Y+0
; 0001 002C 	(dac)->CTRLC = ((dac)->CTRLC & ~( DAC_REFSEL_gm | DAC_LEFTADJ_bm ) ) | convRef | ( leftAdjust ? DAC_LEFTADJ_bm : 0x00 );
; 0001 002D 	(dac)->TIMCTRL = (uint8_t) sampleInterval | refreshInterval;
; 0001 002E 	(dac)->CTRLA |= DAC_CH1EN_bm | DAC_CH0EN_bm | DAC_ENABLE_bm;
; 0001 002F }
;
;
;// ============================ DAC Channel Write ============================
;// [μ] DAC_t *dac,unsigned int data,DAC_CH_t channel
;// Item1: DAC Port (DACA,DACB)
;// Item2: DAC Out Data
;// Item3: CH (CH0,CH1)
;// ----------------------------------------------------------------------------
;void DAC_Channel_Write(DAC_t *dac,unsigned int data,DAC_CH_t channel)
; 0001 0039 {
; 0001 003A 	if(channel == CH0){
;	*dac -> Y+4
;	data -> Y+2
;	channel -> Y+0
; 0001 003B 		(dac)->CH0DATA = data;
; 0001 003C 	}
; 0001 003D 	else{
; 0001 003E 		(dac)->CH1DATA = data;
; 0001 003F 	}
; 0001 0040 }
;
;// ============================ DAC Channel DataEmpty =========================
;// [μ] DAC_t *dac, DAC_CH_t channel
;// Item1: DAC Port (DACA,DACB)
;// Item2: CH (CH0,CH1)
;// ----------------------------------------------------------------------------
;bool DAC_Channel_DataEmpty(DAC_t *dac,DAC_CH_t channel)
; 0001 0048 {
; 0001 0049 bool dacStatus;
; 0001 004A 
; 0001 004B 	dacStatus = ((dac)->STATUS & (channel ? DAC_CH1DRE_bm : DAC_CH0DRE_bm));
;	*dac -> Y+3
;	channel -> Y+1
;	dacStatus -> R17
; 0001 004C 	return(dacStatus);
; 0001 004D }
;
;// ============================ DAC EventAction Set ===========================
;// [μ] DAC_t *dac,DAC_TRIG_t trigChannel,unsigned char eventLine
;// Item1: DAC Port (DACA,DACB)
;// Item2: trigChannel
;// Item3: eventLine
;// ----------------------------------------------------------------------------
;void DAC_EventAction_Set(DAC_t *dac,DAC_TRIG_t trigChannel,unsigned char eventLine)
; 0001 0056 {
; 0001 0057 	(dac)->CTRLB = ((dac)->CTRLB & ~DAC_TRIG_1_1 ) | trigChannel;
;	*dac -> Y+3
;	trigChannel -> Y+1
;	eventLine -> Y+0
; 0001 0058 	(dac)->EVCTRL = eventLine & DAC_EVSEL_gm;
; 0001 0059 }
;// ======================= AtxmegaxxxA1 EX_BUS  α׷ ==================
;//  CPU : ATmegaxxxA1
;//     ¥ : 2010-
;//      : Ver1.0
;//    : www.cpuplaza.com
;// Ϸ : CodeVisionAVR 2.04.6
;// ----------------------------------------------------------------------------
;// ⺻ 
;#include <io.h>							// CPU  
;
;#include <stdint.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <ctype.h>
;#include <stdbool.h>
;
;//  
;#include "ebi_drv.h"						// EBI 
;
;// =============================== EBI Enable =================================
;// [μ] EBI_SDDATAW_t sdramDataWidth, EBI_LPCMODE_t lpcMode, EBI_SRMODE_t sramMode, EBI_IFMODE_t interfaceMode
;// Item1: EBI SDRAM Data Width Setting(EBI_SDDATAW_4BIT_gc,EBI_SDDATAW_8BIT_gc)
;// Item2: EBI SRAM Low Pin-count Mode(EBI_LPCMODE_ALE1_gc,EBI_LPCMODE_ALE12_gc)
;// Item3: SRAM Mode(EBI_SRMODE_ALE1_gc,EBI_SRMODE_ALE2_gc,EBI_SRMODE_ALE12_gc,EBI_SRMODE_NOALE_gc)
;// Item4: EBI Interface Mode(EBI_IFMODE_DISABLED_gc,EBI_IFMODE_3PORT_gc,EBI_IFMODE_4PORT_gc,EBI_IFMODE_2PORT_gc)
;// ----------------------------------------------------------------------------
;void EBI_Enable(EBI_SDDATAW_t sdramDataWidth, EBI_LPCMODE_t lpcMode, EBI_SRMODE_t sramMode, EBI_IFMODE_t interfaceMode)
; 0002 001C {

	.CSEG
; 0002 001D 	EBI.CTRL = (unsigned char)sdramDataWidth | lpcMode | sramMode | interfaceMode;
;	sdramDataWidth -> Y+3
;	lpcMode -> Y+2
;	sramMode -> Y+1
;	interfaceMode -> Y+0
; 0002 001E }
;
;// =============================== EBI EnableSRAM =============================
;// [μ] EBI_CS_t *chipSelect,EBI_CS_ASPACE_t addrSpace,void *baseAddr, unsigned char waitStateCycles
;// Item1: Chip Select(EBI.CS0,EBI.CS1,EBI.CS2,EBI.CS3)
;// Item2: Chip Select Address
;//        (EBI_CS_ASPACE_256B_gc, EBI_CS_ASPACE_512B_gc, EBI_CS_ASPACE_1KB_gc,
;//         EBI_CS_ASPACE_2KB_gc,  EBI_CS_ASPACE_4KB_gc,  EBI_CS_ASPACE_8KB_gc,
;//         EBI_CS_ASPACE_16KB_gc, EBI_CS_ASPACE_32KB_gc, EBI_CS_ASPACE_64KB_gc,
;//         EBI_CS_ASPACE_128KB_gc,EBI_CS_ASPACE_256KB_gc,EBI_CS_ASPACE_512KB_gc,
;//         EBI_CS_ASPACE_1MB_gc,  EBI_CS_ASPACE_2MB_gc,  EBI_CS_ASPACE_4MB_gc,
;//         EBI_CS_ASPACE_8MB_gc,  EBI_CS_ASPACE_16M_gc
;// Item3: Base Address
;// Item4: Wait State(EBI_CS_SRWS_0CLK_gc, EBI_CS_SRWS_1CLK_gc, EBI_CS_SRWS_2CLK_gc, EBI_CS_SRWS_3CLK_gc,
;//                   EBI_CS_SRWS_4CLK_gc, EBI_CS_SRWS_5CLK_gc, EBI_CS_SRWS_6CLK_gc, EBI_CS_SRWS_7CLK_gc
;// ----------------------------------------------------------------------------
;void EBI_EnableSRAM(EBI_CS_t *chipSelect,EBI_CS_ASPACE_t addrSpace,unsigned int baseAddr, unsigned char waitStateCycles)
; 0002 002F {
; 0002 0030 	(chipSelect)->CTRLB = ((chipSelect)->CTRLB & ~EBI_CS_SRWS_gm) | (waitStateCycles & EBI_CS_SRWS_gm);// Configure SRAM settings.
;	*chipSelect -> Y+4
;	addrSpace -> Y+3
;	baseAddr -> Y+1
;	waitStateCycles -> Y+0
; 0002 0031 	(chipSelect)->BASEADDR = (((unsigned int) baseAddr)>>8) & (0xFFFFL<<(addrSpace>>2));// Truncate the base address to an address space boundary.
; 0002 0032 	// Last part of configuration and then enable Chip Select module in SRAM mode.
; 0002 0033 	(chipSelect)->CTRLA = ((chipSelect)->CTRLA & ~(EBI_CS_ASPACE_gm | EBI_CS_MODE_gm)) | addrSpace | EBI_CS_MODE_SRAM_gc;
; 0002 0034 }
;
;// ================================= EBI_EnableLPC ===========================
;// [μ] volatile EBI_CS_t *chipSelect, EBI_CS_ASPACE_t addrSpace, unsigned int baseAddr, unsigned char waitStateCycles
;// Item1: Wait State(EBI_CS_SRWS_0CLK_gc, EBI_CS_SRWS_1CLK_gc, EBI_CS_SRWS_2CLK_gc, EBI_CS_SRWS_3CLK_gc,
;//                   EBI_CS_SRWS_4CLK_gc, EBI_CS_SRWS_5CLK_gc, EBI_CS_SRWS_6CLK_gc, EBI_CS_SRWS_7CLK_gc
;// Item2: Base Address
;// Item3: EBI SRAM Low Pin-count Mode(EBI_LPCMODE_ALE1_gc,EBI_LPCMODE_ALE12_gc)
;// ----------------------------------------------------------------------------
;void EBI_EnableLPC(volatile EBI_CS_t *chipSelect, EBI_CS_ASPACE_t addrSpace, unsigned int baseAddr, unsigned char waitStateCycles)
; 0002 003E {
; 0002 003F 
; 0002 0040 	(chipSelect)->CTRLB = ((chipSelect)->CTRLB & ~EBI_CS_SRWS_gm) | (waitStateCycles & EBI_CS_SRWS_gm);// Configure SRAM LPC settings.
;	*chipSelect -> Y+4
;	addrSpace -> Y+3
;	baseAddr -> Y+1
;	waitStateCycles -> Y+0
; 0002 0041 	(chipSelect)->BASEADDR = (((unsigned long) baseAddr)>>8) & (0xFFFFL<<(addrSpace>>2));// Truncate the base address to an address space boundary.
; 0002 0042 	// Last part of configuration and then enable Chip Select module in SRAM LPC mode.
; 0002 0043 	(chipSelect)->CTRLA = ((chipSelect)->CTRLA & ~(EBI_CS_ASPACE_gm | EBI_CS_MODE_gm)) | addrSpace | EBI_CS_MODE_LPC_gc;
; 0002 0044 }
;
;// ================================= EBI EnableSDRAM ==========================
;// [μ] EBI_CS_ASPACE_t addrSpace, unsigned int baseAddr, bool casLatency, bool rowBits, EBI_SDCOL_t columnBits,
;//        EBI_MRDLY_t modeRegisterDelay, EBI_ROWCYCDLY_t rowCycleDelay, EBI_RPDLY_t rowToPrechargeDelay, EBI_WRDLY_t writeRecoveryDelay,
;//        EBI_ESRDLY_t exitSelfRefreshToActiveDelay, EBI_ROWCOLDLY_t rowToColumnDelay, unsigned int refreshPeriod, unsigned int initializationDelay
;// Item1: Chip Select Address
;//        (EBI_CS_ASPACE_256B_gc, EBI_CS_ASPACE_512B_gc, EBI_CS_ASPACE_1KB_gc,
;//         EBI_CS_ASPACE_2KB_gc,  EBI_CS_ASPACE_4KB_gc,  EBI_CS_ASPACE_8KB_gc,
;//         EBI_CS_ASPACE_16KB_gc, EBI_CS_ASPACE_32KB_gc, EBI_CS_ASPACE_64KB_gc,
;//         EBI_CS_ASPACE_128KB_gc,EBI_CS_ASPACE_256KB_gc,EBI_CS_ASPACE_512KB_gc,
;//         EBI_CS_ASPACE_1MB_gc,  EBI_CS_ASPACE_2MB_gc,  EBI_CS_ASPACE_4MB_gc,
;//         EBI_CS_ASPACE_8MB_gc,  EBI_CS_ASPACE_16M_gc
;// Item2: Base Address
;// Item3: SDRAM CAS Latency Setting
;// Item4:  SDRAM ROW Bits Setting
;// Item5:  SDRAM Column Setting( EBI_SDCOL_8BIT_gc,  EBI_SDCOL_9BIT_gc,
;//                               EBI_SDCOL_10BIT_gc, EBI_SDCOL_11BIT_gc)
;// Item6: Mode Register Delay(EBI_MRDLY_0CLK_gc, EBI_MRDLY_1CLK_gc)
;//                            EBI_MRDLY_2CLK_gc, EBI_MRDLY_3CLK_gc)
;// Item7: Row Cycle Delay(EBI_ROWCYCDLY_0CLK_gc, EBI_ROWCYCDLY_1CLK_gc, EBI_ROWCYCDLY_2CLK_gc
;//                        EBI_ROWCYCDLY_3CLK_gc, EBI_ROWCYCDLY_4CLK_gc, EBI_ROWCYCDLY_5CLK_gc
;//                        EBI_ROWCYCDLY_6CLK_gc, EBI_ROWCYCDLY_7CLK_gc)
;// Item8: Row to Pre-charge Delay(EBI_RPDLY_0CLK_gc, EBI_RPDLY_1CLK_gc, EBI_RPDLY_2CLK_gc,
;//                                EBI_RPDLY_3CLK_gc, EBI_RPDLY_4CLK_gc, EBI_RPDLY_5CLK_gc.
;//                                EBI_RPDLY_6CLK_gc, EBI_RPDLY_7CLK_gc)
;// Item9:  Write Recovery Delay(EBI_WRDLY_0CLK_gc, EBI_WRDLY_1CLK_gc, EBI_WRDLY_2CLK_gc, EBI_WRDLY_3CLK_gc)
;// Item10: Exit Self Refresh to Active Delay(EBI_ESRDLY_0CLK_gc, EBI_ESRDLY_1CLK_gc, EBI_ESRDLY_2CLK_gc, EBI_ESRDLY_3CLK_gc,
;//                             EBI_ESRDLY_4CLK_gc, EBI_ESRDLY_5CLK_gc, EBI_ESRDLY_6CLK_gc, EBI_ESRDLY_7CLK_gc)
;// Item11: Row to Column Delay(EBI_ROWCOLDLY_0CLK_gc, EBI_ROWCOLDLY_1CLK_gc, EBI_ROWCOLDLY_2CLK_gc, EBI_ROWCOLDLY_3CLK_gc,
;//                             EBI_ROWCOLDLY_4CLK_gc, EBI_ROWCOLDLY_5CLK_gc, EBI_ROWCOLDLY_6CLK_gc, EBI_ROWCOLDLY_7CLK_gc)
;// Item12: Refresh Period
;// Item13: Initialization Delay
;// ----------------------------------------------------------------------------
;void EBI_EnableSDRAM( EBI_CS_ASPACE_t addrSpace, unsigned int baseAddr, bool casLatency, bool rowBits, EBI_SDCOL_t columnBits,
; 0002 0067                       EBI_MRDLY_t modeRegisterDelay, EBI_ROWCYCDLY_t rowCycleDelay, EBI_RPDLY_t rowToPrechargeDelay, EBI_WRDLY_t writeRecoveryDelay,
; 0002 0068                       EBI_ESRDLY_t exitSelfRefreshToActiveDelay, EBI_ROWCOLDLY_t rowToColumnDelay, unsigned int refreshPeriod, unsigned int initializationDelay)
; 0002 0069 {
; 0002 006A 	// Set two single-bit fields and one larger field, while protecting reserved bits.
; 0002 006B 	EBI.SDRAMCTRLA = (EBI.SDRAMCTRLA & ~(EBI_SDCAS_bm | EBI_SDROW_bm | EBI_SDCOL_gm)) | (casLatency ? EBI_SDCAS_bm : 0) | (rowBits ? EBI_SDROW_bm : 0) | columnBits;
;	addrSpace -> Y+15
;	baseAddr -> Y+13
;	casLatency -> Y+12
;	rowBits -> Y+11
;	columnBits -> Y+10
;	modeRegisterDelay -> Y+9
;	rowCycleDelay -> Y+8
;	rowToPrechargeDelay -> Y+7
;	writeRecoveryDelay -> Y+6
;	exitSelfRefreshToActiveDelay -> Y+5
;	rowToColumnDelay -> Y+4
;	refreshPeriod -> Y+2
;	initializationDelay -> Y+0
; 0002 006C 
; 0002 006D 	// Set delay counts. Fields fill up the entire registers.
; 0002 006E 	EBI.SDRAMCTRLB = (unsigned char) modeRegisterDelay | rowCycleDelay | rowToPrechargeDelay;
; 0002 006F 	EBI.SDRAMCTRLC = (unsigned char) writeRecoveryDelay | exitSelfRefreshToActiveDelay | rowToColumnDelay;
; 0002 0070 
; 0002 0071 	// Set refresh period and initialization delay, truncate too large values.
; 0002 0072 	EBI.REFRESH = refreshPeriod & 0x03FF;
; 0002 0073 	EBI.INITDLY = initializationDelay & 0x3FFF;
; 0002 0074 
; 0002 0075 	// Last part of configuration and then enable Chip Select module in SDRAM mode.
; 0002 0076 	EBI.CS3.CTRLB = (EBI.CS3.CTRLB & ~(EBI_CS_SDSREN_bm | EBI_CS_SDMODE_gm)) | EBI_CS_SDMODE_NORMAL_gc;
; 0002 0077 
; 0002 0078 	EBI.CS3.BASEADDR = (((unsigned long)baseAddr)>>8) & (0xFFFFL<<(addrSpace>>2));// Truncate the base address to an address space boundary.
; 0002 0079 	EBI.CS3.CTRLA = (EBI.CS3.CTRLA & ~(EBI_CS_ASPACE_gm | EBI_CS_MODE_gm)) | addrSpace | EBI_CS_MODE_SDRAM_gc;
; 0002 007A 	while ((EBI.CS3.CTRLB & EBI_CS_SDINITDONE_bm) == 0);	// Wait for SDRAM to initialize
; 0002 007B }
;// ======================== AtxmegaxxxA1 CPU PORT  α׷ ===============
;//  CPU : ATmegaxxxA1
;//     ¥ : 2010-
;//      : Ver1.0
;//    : www.cpuplaza.com
;// Ϸ : CodeVisionAVR 2.04.6
;// ----------------------------------------------------------------------------
;// ⺻ 
;#include <io.h>							// CPU  
;
;#include <stdint.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <ctype.h>
;
;//  
;#include "port_drv.h"						// cpu port 
;
;// Լ 
;
;// ========================== Port Pin Configuration =========================
;// [μ] PORT_t *port, unsigned char MpcMask, unsigned char SlewRate,
;//        unsigned char Inverted, PORT_OPC_t OutputPull,PORT_ISC_t InputSense
;// Item1: I/O PORT 
;// Item2: Multi Pin Configuration Mask Register
;// Item3: Slew Rate Limit Enable
;// Item4: Inverted I/O Enable
;// Item5: Output and Pull Configuration(TOTEM,BUSKEEPER,PULLDOWN,PULLUP,WIREDOR,WIREDAND,WIREDORPULL,WIREDANDPULL)
;// Item6: Input/Sense Configuration(BOTHEDGES,RISING,FALLING,LEVEL,INPUT_DISABLE)
;// ----------------------------------------------------------------------------
;void PORT_ConfigurePins(PORT_t *port, unsigned char MpcMask, unsigned char SlewRate, unsigned char Inverted, PORT_OPC_t OutputPull,PORT_ISC_t InputSense)
; 0003 0020 {

	.CSEG
; 0003 0021 unsigned char datac;
; 0003 0022 
; 0003 0023 	datac = (unsigned char)(OutputPull | InputSense);	// PINnCTRL ISC[0..2], OPC[3..5]
;	*port -> Y+6
;	MpcMask -> Y+5
;	SlewRate -> Y+4
;	Inverted -> Y+3
;	OutputPull -> Y+2
;	InputSense -> Y+1
;	datac -> R17
; 0003 0024 	if(SlewRate) datac |= PORT_SRLEN_bm;			// SRLEN bit
; 0003 0025 	if(Inverted) datac |= PORT_INVEN_bm;			// INVEN bit
; 0003 0026 
; 0003 0027 	PORTCFG.MPCMASK = MpcMask;				// Multi Pin Configuration Mask Register
; 0003 0028 	(port)->PIN0CTRL = datac;				// Pin Configuration Register
; 0003 0029 }
;
;// ========================= PORT Interrupt0 Configure =========================
;// [μ] PORT_t *port,PORT_INT0LVL_t intLevel,unsigned char pinMask
;// Item1: I/O PORT 
;// Item2: Interrupt Level(OFF,LO,MED,HI)
;// Item3: Interrupt Mask Register
;// ----------------------------------------------------------------------------
;void PORT_ConfigureInterrupt0(PORT_t *port,PORT_INT0LVL_t IntLevel,unsigned char IntMask)
; 0003 0032 {
; 0003 0033 	(port)->INTCTRL = ((port)->INTCTRL & ~PORT_INT0LVL_gm ) | IntLevel;// Interrupt Control Register : INT0LVL[0..1]
;	*port -> Y+2
;	IntLevel -> Y+1
;	IntMask -> Y+0
; 0003 0034 	(port)->INT0MASK = IntMask;				// INT0MASK[0..7]
; 0003 0035 }
;
;// ========================= PORT Interrupt1 Configure =========================
;// [μ] PORT_t *port,PORT_INT0LVL_t intLevel,unsigned char pinMask
;// Item1: I/O PORT 
;// Item2: Interrupt Level(OFF,LO,MED,HI)
;// Item3: Interrupt Mask Register
;// ----------------------------------------------------------------------------
;void PORT_ConfigureInterrupt1(PORT_t *port,PORT_INT1LVL_t IntLevel,unsigned char IntMask)
; 0003 003E {
; 0003 003F 	(port)->INTCTRL = ((port)->INTCTRL & ~PORT_INT1LVL_gm ) | IntLevel;// Interrupt Control Register : INT0LVL[0..1]
;	*port -> Y+2
;	IntLevel -> Y+1
;	IntMask -> Y+0
; 0003 0040 	(port)->INT1MASK = IntMask;				// INT0MASK[0..7]
; 0003 0041 }
;
;// ========================= Virtual Port0 map Control ========================
;// [μ] PORTCFG_VP0MAP_t port
;// Item1:  I/O PORT 
;// ----------------------------------------------------------------------------
;void PORT_MapVirtualPort0(PORTCFG_VP0MAP_t port)
; 0003 0048 {
; 0003 0049 	PORTCFG.VPCTRLA = (PORTCFG.VPCTRLA & ~PORTCFG_VP0MAP_gm ) | port;
;	port -> Y+0
; 0003 004A }
;
;// ========================= Virtual Port1 map Control ========================
;// [μ] PORTCFG_VP0MAP_t port
;// Item1:  I/O PORT 
;// ----------------------------------------------------------------------------
;void PORT_MapVirtualPort1(PORTCFG_VP0MAP_t port)
; 0003 0051 {
; 0003 0052 	PORTCFG.VPCTRLA = (PORTCFG.VPCTRLA & ~PORTCFG_VP1MAP_gm ) | port;
;	port -> Y+0
; 0003 0053 }
;
;// ========================= Virtual Port2 map Control ========================
;// [μ] PORTCFG_VP0MAP_t port
;// Item1:  I/O PORT 
;// ----------------------------------------------------------------------------
;void PORT_MapVirtualPort2(PORTCFG_VP0MAP_t port)
; 0003 005A {
; 0003 005B 	PORTCFG.VPCTRLB = (PORTCFG.VPCTRLB & ~PORTCFG_VP2MAP_gm ) | port;
;	port -> Y+0
; 0003 005C }
;
;// ========================= Virtual Port3 map Control ========================
;// [μ] PORTCFG_VP0MAP_t port
;// Item1:  I/O PORT 
;// ----------------------------------------------------------------------------
;void PORT_MapVirtualPort3(PORTCFG_VP0MAP_t port)
; 0003 0063 {
; 0003 0064 	PORTCFG.VPCTRLB = (PORTCFG.VPCTRLB & ~PORTCFG_VP3MAP_gm ) | port;
;	port -> Y+0
; 0003 0065 }
;
;// ========================= XMEGA64_A1 ZigBee SLAVE1 α׷ ===============
;//  CPU : ATmega64A1
;//     ¥ : 2010-
;//      : Ver1.0
;//    : www.cpuplaza.com
;// Ϸ : CodeVisionAVR 2.04.7
;//      : Master/SLAVE1/SLAVE2  
;//            COM7-RS232(PC)    : 19200,N,8,1
;//            COM8-RS485(XBee)  : 9600,N,8,1
;// PortF.4(OUT) : RST\(L:,H:Reset)
;// PortF.5(OUT) : XBee Sleep(0:NON,1:SLEEP) ::    .
;// ----------------------------------------------------------------------------
;//  
;#define	STX	0x02						// COM  ڵ
;#define	ETX	0x03						// COM    ڵ
;#define	SLAVE_NUM	'1'					// SLAVE ȣ('1' -  '2')
;
;// ⺻ 
;#include <io.h>							// CPU  
;
;#include <stdint.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <ctype.h>
;#include <stdbool.h>
;#include <delay.h>
;//#include <float.h>
;//#include <math.h>
;
;//  ۼ ̺귯 
;#include "port_drv.h"						// CPU Ʈ 
;#include "usart_drv.h"						//  
;#include "adc_drv.h"						// ADC 
;#include "dac_drv.h"						// DAC 
;#include "ebi_drv.h"						// EX BUS(SRAM,SDRAM) 
;
;//  
;#include "cpusetup.inc"						// cpu  ͷƮ  ƾ
;// =================================== CPUʱȭ ͷƮ ===================
;//      : CPU  ͷƮ  ƾ
;// ----------------------------------------------------------------------------
;//   
;
;// Լ 
;
;//  
;char com7_rx_data,com7_rx_eflg = 0;				// COM7   ͷƮ  /÷
;char com8_rx_data[50],com8_rx_eflg = 0;				// COM8   ͷƮ  /÷
;int com8_rx_usi = 0,com8_rx_udi = 0;				// COM8   
;
;int timer0_base_cnt = 0;					// Ÿ̸0 ͷƮ  ī
;int timer0_tx_cnt = 0;						// Ÿ̸0 ſ ī
;
;// ===================================== CPUʱȭ ============================
;// [μ] void
;// ----------------------------------------------------------------------------
;void cpu_setup(void)
; 0004 0026 {

	.CSEG
_cpu_setup:
;unsigned char uch;
;
;#asm("cli")							// ͷƮ 
	ST   -Y,R17
;	uch -> R17
	cli
;
;// system clock setup
;	// external oscillator initialization
;	OSC.XOSCCTRL = OSC_FRQRANGE_12TO16_gc | OSC_XOSCSEL_XTAL_16KCLK_gc;// XTAL 8MHz, 16K CLK startup time
	LDI  R30,LOW(203)
	STS  82,R30
;	OSC.CTRL = OSC_XOSCEN_bm;				// external oscillator enable
	LDI  R30,LOW(8)
	STS  80,R30
;	while((OSC.STATUS & OSC_XOSCRDY_bm) == 0);		// external clock source ready
_0x80003:
	LDS  R30,81
	ANDI R30,LOW(0x8)
	BREQ _0x80003
;
;	// PLL initialization
;	uch = OSC_PLLSRC_XOSC_gc | 4;				// PLL clock source XTAL, multiplication factor = 4(8MHz*4 = 32MHz)
	LDI  R17,LOW(196)
;	CCP = CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	LDI  R30,LOW(216)
	OUT  0x34,R30
;	OSC.PLLCTRL = uch;
	STS  85,R17
;	OSC.CTRL |= OSC_PLLEN_bm;				// Enable the PLL
	LDS  R30,80
	ORI  R30,0x10
	STS  80,R30
;
;	// System clock prescalers A,B,C set
;	// clkPer4: 32MHz
;	// clkPer2: 32MHz
;	// clkPer : 32MHz
;	// clkCPU : 32MHz
;	uch = CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;		// prescaler division factor(A=1, B=1, C=1)
	LDI  R17,LOW(0)
;	CCP = CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	LDI  R30,LOW(216)
	OUT  0x34,R30
;	CLK.PSCTRL = uch;
	STS  65,R17
;	while((OSC.STATUS & OSC_PLLRDY_bm) == 0);		// PLL ready
_0x80006:
	LDS  R30,81
	ANDI R30,LOW(0x10)
	BREQ _0x80006
;
;	// select the system clock source
;	uch = CLK_SCLKSEL_PLL_gc;				// Select the system clock source: Phase Locked Loop
	LDI  R17,LOW(4)
;	CCP=CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	LDI  R30,LOW(216)
	OUT  0x34,R30
;	CLK.CTRL = uch;
	STS  64,R17
;
;// portc_7 system clock output
;//	PORTCFG.CLKEVOUT = PORTCFG_CLKOUT_PC7_gc;		// poetc_7 bit clock output
;//	PORTC.DIRSET |= 0x80;
;// PORTF XBee   ʱȭ
;// PORTF.4(OUT) : RST\(L:,H:Reset)
;// PORTF.5(OUT) : Sleep( L)
;	PORTF.OUT = 0x10;
	LDI  R30,LOW(16)
	STS  1700,R30
;	PORTF.DIRSET = 0x30;
	LDI  R30,LOW(48)
	STS  1697,R30
;
;// Timer/Counter TCC0 (Overflow) 9.9984ms :: LED ¿
;// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
;	TCC0.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz
	LDI  R30,LOW(6)
	STS  2048,R30
;
;	// Normal Operation, Overflow Int./Event = TOP
;	// Compare/Capture channel A,B,C,D: Off
;	TCC0.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	LDI  R30,LOW(0)
	STS  2049,R30
;	TCC0.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	STS  2051,R30
;	TCC0.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	LDI  R30,LOW(1)
	STS  2054,R30
;	TCC0.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc | TC_CCCINTLVL_OFF_gc | TC_CCDINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	LDI  R30,LOW(0)
	STS  2055,R30
;	TCC0.INTFLAGS ^= TCC0.INTFLAGS;				// Clear the interrupt flags
	LDI  R26,LOW(2060)
	LDI  R27,HIGH(2060)
	MOV  R0,R26
	LD   R26,X
	LDS  R30,2060
	EOR  R30,R26
	MOV  R26,R0
	ST   X,R30
;
;	TCC0.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	CALL SUBOPT_0x0
;	TCC0.PER = 0x0000;					// Set period register
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  2086,R30
	STS  2086+1,R31
;	TCC0.CCA = 0x0000;					// Compare,Capture register
	STS  2088,R30
	STS  2088+1,R31
;	TCC0.CCB = 0x0000;
	STS  2090,R30
	STS  2090+1,R31
;	TCC0.CCC = 0x0000;
	STS  2092,R30
	STS  2092+1,R31
;	TCC0.CCD = 0x0000;
	STS  2094,R30
	STS  2094+1,R31
;
;// USART 
;//	Com_Init(&USARTC0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM1(PORTC0) ASYNC,19200,8,N,1 
;//	Com_Init(&USARTC1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM2(PORTC1) ASYNC,19200,8,N,1 
;//	Com_Init(&USARTD0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM3(PORTD0) ASYNC,19200,8,N,1 
;//	Com_Init(&USARTD1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM4(PORTD1) ASYNC,19200,8,N,1 
;//	Com_Init(&USARTE0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM5(PORTE0) ASYNC,19200,8,N,1 
;//	Com_Init(&USARTE1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM6(PORTE1) ASYNC,19200,8,N,1 
;	Com_Init(&USARTF0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM7(PORTF0) ASYNC,19200,8,N,1 
	LDI  R30,LOW(2976)
	LDI  R31,HIGH(2976)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETD1N 0x4B00
	CALL SUBOPT_0x1
;	Com_Init(&USARTF1, USART_CMODE_ASYNCHRONOUS_gc,  9600L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM8(PORTF1) ASYNC, 9600,8,N,1 
	LDI  R30,LOW(2992)
	LDI  R31,HIGH(2992)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETD1N 0x2580
	CALL SUBOPT_0x1
;
;	PMIC.CTRL |= PMIC_LOLVLEX_bm;				// Enable PMIC interrupt level low.(PMIC_LOLVLEX_bm, PMIC_MEDLVLEX_bm, PMIC_HILVLEX_bm)
	LDS  R30,162
	ORI  R30,1
	STS  162,R30
;
;#asm("sei")							// ͷƮ 㰡
	sei
;}
	LD   R17,Y+
	RET
;
;// =========================== USARTF0  ͷƮ ==========================
;// [μ] void
;// ----------------------------------------------------------------------------
;interrupt [USARTF0_RXC_vect] void usartf0_rx_isr(void)
;{
_usartf0_rx_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;unsigned char status, data;
;
;	status = USARTF0.STATUS;				//   
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,2977
;	data = USARTF0.DATA;					//   
	LDS  R16,2976
;	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x80009
;		com7_rx_data = data;				//  
	MOV  R3,R16
;		com7_rx_eflg = 1;				//  Ϸ flag set
	LDI  R30,LOW(1)
	MOV  R2,R30
;	}
;}
_0x80009:
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;// =========================== USARTF1  ͷƮ ==========================
;// [μ] void
;// ----------------------------------------------------------------------------
;interrupt [USARTF1_RXC_vect] void usartf1_rx_isr(void)
;{
_usartf1_rx_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;unsigned char status, data;
;
;	status = USARTF1.STATUS;				//   
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,2993
;	data = USARTF1.DATA;					//   
	LDS  R16,2992
;	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x8000A
;		if(com8_rx_eflg == 0){				//    ó ƴҶ
	TST  R5
	BRNE _0x8000B
;			if(data == STX){			//  ڵ ã
	CPI  R16,2
	BRNE _0x8000C
;				com8_rx_usi = 0;		//   Ŭ
	CLR  R6
	CLR  R7
;				com8_rx_data[com8_rx_usi++] = data;// STX 
	CALL SUBOPT_0x2
;			}
;			else if(data == ETX){			//  ڵ ã
	RJMP _0x8000D
_0x8000C:
	CPI  R16,3
	BRNE _0x8000E
;				com8_rx_data[com8_rx_usi++] = data;// ETX 
	CALL SUBOPT_0x2
;				com8_rx_data[com8_rx_usi] = 0;	// NULL  
	LDI  R26,LOW(_com8_rx_data)
	LDI  R27,HIGH(_com8_rx_data)
	ADD  R26,R6
	ADC  R27,R7
	LDI  R30,LOW(0)
	ST   X,R30
;				com8_rx_udi = com8_rx_usi;	//   ( ó )
	MOVW R8,R6
;				com8_rx_eflg = 1;		//  Ϸ ÷ ON( ó )
	LDI  R30,LOW(1)
	MOV  R5,R30
;				com8_rx_usi = 0;		//   Ŭ
	RJMP _0x8002A
;			}
;			else{
_0x8000E:
;				com8_rx_data[com8_rx_usi++] = data;//  
	CALL SUBOPT_0x2
;				if(com8_rx_usi >= 45) com8_rx_usi = 0;//  ʰ ˻
	LDI  R30,LOW(45)
	LDI  R31,HIGH(45)
	CP   R6,R30
	CPC  R7,R31
	BRLT _0x80010
_0x8002A:
	CLR  R6
	CLR  R7
;			}
_0x80010:
_0x8000D:
;		}
;	}
_0x8000B:
;}
_0x8000A:
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;// ============================ TCC0 overflow ͷƮ ========================
;// [μ] void
;// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
;// ----------------------------------------------------------------------------
;interrupt [TCC0_OVF_vect] void tcc0_overflow_isr(void)
;{
_tcc0_overflow_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;	TCC0.CNT = 64285;					// 65535-1250 = 64285
	CALL SUBOPT_0x0
;	timer0_base_cnt++;					// Ÿ̸0 ⺻   ī 10ms
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
;	timer0_tx_cnt++;					// Ÿ̸0 ſ ī 10ms
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
;}
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;// Լ 
;void Master_Send(char num);					// Master  
;int LrcCul(char buf[],int max_cnt);				// SLAE FRAME  LRC
;
;//  
;int tx_cnt = 0;							//  ī
;
;// ===============================  α׷ =============================
;// [μ]: void
;// ---------------------------------------------------------------------------
;void main(void)
; 0004 0033 {
_main:
; 0004 0034 char buf[10];
; 0004 0035 int crc;
; 0004 0036 
; 0004 0037 	cpu_setup();						// cpuʱȭ
	SBIW R28,10
;	buf -> Y+0
;	crc -> R16,R17
	RCALL _cpu_setup
; 0004 0038 
; 0004 0039 	PORTD.OUT &= ~0x10;					// Zigbee Reset
	LDS  R30,1636
	ANDI R30,0xEF
	STS  1636,R30
; 0004 003A 	timer0_base_cnt = 0;					// ð 500ms
	CLR  R10
	CLR  R11
; 0004 003B 	while(timer0_base_cnt < 50);
_0x80011:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R10,R30
	CPC  R11,R31
	BRLT _0x80011
; 0004 003C 	PORTD.OUT |= 0x10;					// Zigbee NON Reset
	LDS  R30,1636
	ORI  R30,0x10
	STS  1636,R30
; 0004 003D 	timer0_base_cnt = 0;					// ð 1S
	CLR  R10
	CLR  R11
; 0004 003E 	while(timer0_base_cnt < 100);
_0x80014:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R10,R30
	CPC  R11,R31
	BRLT _0x80014
; 0004 003F 
; 0004 0040 	timer0_tx_cnt = 0;					// ۽ Ÿ̸ ʱȭ
	CLR  R12
	CLR  R13
; 0004 0041 	while(1){						// Place your code here
_0x80017:
; 0004 0042 		if(com8_rx_eflg){				// SLAVE  ó
	TST  R5
	BRNE PC+3
	JMP _0x8001A
; 0004 0043 			if(com8_rx_data[1] == SLAVE_NUM){	// ڱ  ȣ ˻
	__GETB2MN _com8_rx_data,1
	CPI  R26,LOW(0x31)
	BRNE _0x8001B
; 0004 0044 				crc = LrcCul(com8_rx_data,com8_rx_udi-3) & 0xff;// üũ 
	LDI  R30,LOW(_com8_rx_data)
	LDI  R31,HIGH(_com8_rx_data)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R8
	SBIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	RCALL _LrcCul
	ANDI R31,HIGH(0xFF)
	MOVW R16,R30
; 0004 0045 				sprintf(buf,"%02X",crc);
	MOVW R30,R28
	CALL SUBOPT_0x3
	MOVW R30,R16
	CALL SUBOPT_0x4
; 0004 0046 				if(buf[0] == com8_rx_data[com8_rx_udi-3] && buf[1] == com8_rx_data[com8_rx_udi-2]){// LRC OK?
	MOVW R30,R8
	SBIW R30,3
	SUBI R30,LOW(-_com8_rx_data)
	SBCI R31,HIGH(-_com8_rx_data)
	LD   R30,Z
	LD   R26,Y
	CP   R30,R26
	BRNE _0x8001D
	MOVW R30,R8
	SBIW R30,2
	SUBI R30,LOW(-_com8_rx_data)
	SBCI R31,HIGH(-_com8_rx_data)
	LD   R30,Z
	LDD  R26,Y+1
	CP   R30,R26
	BREQ _0x8001E
_0x8001D:
	RJMP _0x8001C
_0x8001E:
; 0004 0047 					Master_Send(SLAVE_NUM);	// Master  
	LDI  R30,LOW(49)
	ST   -Y,R30
	RCALL _Master_Send
; 0004 0048 					tx_cnt++;		//  ī 
	LDS  R30,_tx_cnt
	LDS  R31,_tx_cnt+1
	ADIW R30,1
	STS  _tx_cnt,R30
	STS  _tx_cnt+1,R31
; 0004 0049 					if(tx_cnt >= 9999) tx_cnt = 0;// 0 -> 9999 -> 0
	LDS  R26,_tx_cnt
	LDS  R27,_tx_cnt+1
	CPI  R26,LOW(0x270F)
	LDI  R30,HIGH(0x270F)
	CPC  R27,R30
	BRLT _0x8001F
	LDI  R30,LOW(0)
	STS  _tx_cnt,R30
	STS  _tx_cnt+1,R30
; 0004 004A 				}
_0x8001F:
; 0004 004B 			}
_0x8001C:
; 0004 004C 			com8_rx_eflg = 0;
_0x8001B:
	CLR  R5
; 0004 004D 		}
; 0004 004E 	}
_0x8001A:
	RJMP _0x80017
; 0004 004F }
_0x80020:
	RJMP _0x80020
;
;// ========================== Master   ===========================
;// [μ]: char num
;// Item1 :  SLAVE ȣ('1'-'2')
;// ---------------------------------------------------------------------------
;void Master_Send(char num)
; 0004 0056 {
_Master_Send:
; 0004 0057 char buf[10];
; 0004 0058 char com_tx_buf[50];
; 0004 0059 int i = 0,j,crc = 0;
; 0004 005A 
; 0004 005B 	com_tx_buf[i++] = STX;					// STX
	SBIW R28,60
	CALL __SAVELOCR6
;	num -> Y+66
;	buf -> Y+56
;	com_tx_buf -> Y+6
;	i -> R16,R17
;	j -> R18,R19
;	crc -> R20,R21
	__GETWRN 16,17,0
	__GETWRN 20,21,0
	CALL SUBOPT_0x5
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(2)
	ST   X,R30
; 0004 005C 	com_tx_buf[i++] = num;					// NUM
	CALL SUBOPT_0x5
	ADD  R30,R26
	ADC  R31,R27
	__GETB2SX 66
	STD  Z+0,R26
; 0004 005D 	com_tx_buf[i++] = 'R';					// COMMAND
	CALL SUBOPT_0x5
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(82)
	ST   X,R30
; 0004 005E 
; 0004 005F 	sprintf(buf,"%04d",tx_cnt);				// ī  4byte int
	MOVW R30,R28
	ADIW R30,56
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x80000,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_tx_cnt
	LDS  R31,_tx_cnt+1
	CALL SUBOPT_0x4
; 0004 0060 	com_tx_buf[i++] = buf[0];
	CALL SUBOPT_0x5
	CALL SUBOPT_0x6
; 0004 0061 	com_tx_buf[i++] = buf[1];
	CALL SUBOPT_0x7
; 0004 0062 	com_tx_buf[i++] = buf[2];
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+58
	STD  Z+0,R26
; 0004 0063 	com_tx_buf[i++] = buf[3];
	CALL SUBOPT_0x5
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+59
	STD  Z+0,R26
; 0004 0064 
; 0004 0065 	for(j = 0; j < i; j++) crc ^= com_tx_buf[j];		// LRC 
	__GETWRN 18,19,0
_0x80022:
	__CPWRR 18,19,16,17
	BRGE _0x80023
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R18
	ADC  R27,R19
	LD   R30,X
	LDI  R31,0
	__EORWRR 20,21,30,31
	__ADDWRN 18,19,1
	RJMP _0x80022
_0x80023:
; 0004 0066 sprintf(buf,"%02X",crc&0xff);
	MOVW R30,R28
	ADIW R30,56
	CALL SUBOPT_0x3
	MOVW R30,R20
	ANDI R31,HIGH(0xFF)
	CALL SUBOPT_0x4
; 0004 0067 	com_tx_buf[i++] = buf[0];				// LRC High
	CALL SUBOPT_0x5
	CALL SUBOPT_0x6
; 0004 0068 	com_tx_buf[i++] = buf[1];    				// LRC Low
	CALL SUBOPT_0x7
; 0004 0069 	com_tx_buf[i++] = ETX;       				// ETX
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(3)
	ST   X,R30
; 0004 006A 	com_tx_buf[i] = 0;       				// NULL
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R16
	ADC  R27,R17
	LDI  R30,LOW(0)
	ST   X,R30
; 0004 006B 
; 0004 006C 	for(j = 0; j < i; j++) putchar_8(com_tx_buf[j]);	//  ۽(COM8)
	__GETWRN 18,19,0
_0x80025:
	__CPWRR 18,19,16,17
	BRGE _0x80026
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R18
	ADC  R27,R19
	LD   R30,X
	ST   -Y,R30
	RCALL _putchar_8
	__ADDWRN 18,19,1
	RJMP _0x80025
_0x80026:
; 0004 006E printf("send : %s\r\n",com_tx_buf);
	__POINTW1FN _0x80000,10
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
; 0004 006F }
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,4
	RET
;
;// =========================== LRC  ==========================
;// [μ] char buf[],int max_cnt
;// Item1:  ڷ 
;// Item2: ڷ 
;// [] 
;// ----------------------------------------------------------------
;int LrcCul(char buf[],int max_cnt)
; 0004 0078 {
_LrcCul:
; 0004 0079 int i,accum = 0;
; 0004 007A 
; 0004 007B 	for(i = 0; i < max_cnt;i++) accum ^= buf[i];		// XOR 
	CALL __SAVELOCR4
;	buf -> Y+6
;	max_cnt -> Y+4
;	i -> R16,R17
;	accum -> R18,R19
	__GETWRN 18,19,0
	__GETWRN 16,17,0
_0x80028:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x80029
	MOVW R30,R16
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	__EORWRR 18,19,30,31
	__ADDWRN 16,17,1
	RJMP _0x80028
_0x80029:
; 0004 007C return(accum & 0xff);
	MOVW R30,R18
	ANDI R31,HIGH(0xFF)
	CALL __LOADLOCR4
	ADIW R28,8
	RET
; 0004 007D }
;// ========================= AtxmegaxxxA1 USART  α׷ =================
;//  CPU : ATmegaxxxA1
;//     ¥ : 2010-
;//      : Ver1.0
;// Ϸ : CodeVisionAVR 2.04.6
;// Ϸ : AVRstudio4.18
;// ----------------------------------------------------------------------------
;// ⺻ 
;#include <io.h>							// CPU  
;
;#include <stdint.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <ctype.h>
;
;#define _ALTERNATE_PUTCHAR_					// putchar() üϱ  
;
;//  
;//#include "usart_drv.h"					// usart 
;
;// ============================== USART Port Init ============================
;// [μ] USART_t *usart, unsigned char c_mode, long baud, unsigned char data_size
;//        unsigned char p_mode, unsigned char sb_mode
;// Item1: USART Port (USARTC0,USARTC1,USARTD0,USARTD1,USARTE0,USARTE1,USARTF0,USARTF1)
;// Item2: commucation mode(USART_CMODE_ASYNCHRONOUS_gc, USART_CMODE_SYNCHRONOUS_gc,
;//                         USART_CMODE_IRDA_gc, USART_CMODE_MSPI_gc)
;// Item3: baud rate(300,600,1200,2400,4800,9600,19200,38400,57600,115200)
;// Item4: data size(USART_CHSIZE_5BIT_gc,USART_CHSIZE_6BIT_gc,USART_CHSIZE_7BIT_gc,
;//                  USART_CHSIZE_8BIT_gc,USART_CHSIZE_9BIT_gc)
;// Item5: parity mode(USART_PMODE_DISABLED_gc, USART_PMODE_EVEN_gc, USART_PMODE_ODD_gc)
;// Item6: stop mode(1STOP(1), 2STOPO(2))
;// ----------------------------------------------------------------------------
;void Com_Init(USART_t *usart, unsigned char c_mode, long baud, unsigned char data_size, unsigned char p_mode, unsigned char sb_mode)
; 0005 0022 {

	.CSEG
_Com_Init:
; 0005 0023 unsigned char stop_c = 0;
; 0005 0024 
; 0005 0025 	if(usart == &USARTC0){
	ST   -Y,R17
;	*usart -> Y+9
;	c_mode -> Y+8
;	baud -> Y+4
;	data_size -> Y+3
;	p_mode -> Y+2
;	sb_mode -> Y+1
;	stop_c -> R17
	LDI  R17,0
	LDI  R30,LOW(2208)
	LDI  R31,HIGH(2208)
	CALL SUBOPT_0x8
	BRNE _0xA0003
; 0005 0026 		PORTC.DIR &= ~PIN2_bm;				// PORTC_2 Input
	LDS  R30,1600
	ANDI R30,0xFB
	STS  1600,R30
; 0005 0027 		PORTC.DIR |= PIN3_bm;				// PORTC_3 Output
	LDS  R30,1600
	ORI  R30,8
	STS  1600,R30
; 0005 0028 		PORTC.OUT |= PIN3_bm;				// PORTC_3 = 1
	LDS  R30,1604
	ORI  R30,8
	STS  1604,R30
; 0005 0029 	}
; 0005 002A 	if(usart == &USARTD0){
_0xA0003:
	LDI  R30,LOW(2464)
	LDI  R31,HIGH(2464)
	CALL SUBOPT_0x8
	BRNE _0xA0004
; 0005 002B 		PORTD.DIR &= ~PIN2_bm;				// PORTD_2 Input
	LDS  R30,1632
	ANDI R30,0xFB
	STS  1632,R30
; 0005 002C 		PORTD.DIR |= PIN3_bm;				// PORTD_3 Output
	LDS  R30,1632
	ORI  R30,8
	STS  1632,R30
; 0005 002D 		PORTD.OUT |= PIN3_bm;				// PORTD_3 = 1
	LDS  R30,1636
	ORI  R30,8
	STS  1636,R30
; 0005 002E 	}
; 0005 002F 	if(usart == &USARTE0){
_0xA0004:
	LDI  R30,LOW(2720)
	LDI  R31,HIGH(2720)
	CALL SUBOPT_0x8
	BRNE _0xA0005
; 0005 0030 		PORTE.DIR &= ~PIN2_bm;				// PORTF_2 Input
	LDS  R30,1664
	ANDI R30,0xFB
	STS  1664,R30
; 0005 0031 		PORTE.DIR |= PIN3_bm;				// PORTE_3 Output
	LDS  R30,1664
	ORI  R30,8
	STS  1664,R30
; 0005 0032 		PORTE.OUT |= PIN3_bm;				// PORTE_3 = 1
	LDS  R30,1668
	ORI  R30,8
	STS  1668,R30
; 0005 0033 	}
; 0005 0034 	if(usart == &USARTF0){
_0xA0005:
	LDI  R30,LOW(2976)
	LDI  R31,HIGH(2976)
	CALL SUBOPT_0x8
	BRNE _0xA0006
; 0005 0035 		PORTF.DIR &= ~PIN2_bm;				// PORTF_2 Input
	LDS  R30,1696
	ANDI R30,0xFB
	STS  1696,R30
; 0005 0036 		PORTF.DIR |= PIN3_bm;				// PORTF_3 Output
	LDS  R30,1696
	ORI  R30,8
	STS  1696,R30
; 0005 0037 		PORTF.OUT |= PIN3_bm;				// PORTF_3 = 1
	LDS  R30,1700
	ORI  R30,8
	STS  1700,R30
; 0005 0038 	}
; 0005 0039 	if(usart == &USARTC1){
_0xA0006:
	LDI  R30,LOW(2224)
	LDI  R31,HIGH(2224)
	CALL SUBOPT_0x8
	BRNE _0xA0007
; 0005 003A 		PORTC.DIR &= ~PIN6_bm;				// PORTC_6 Input
	LDS  R30,1600
	ANDI R30,0xBF
	STS  1600,R30
; 0005 003B 		PORTC.DIR |= PIN7_bm;				// PORTC_7 Output
	LDS  R30,1600
	ORI  R30,0x80
	STS  1600,R30
; 0005 003C 		PORTC.OUT |= PIN7_bm;				// PORTC_7 = 1
	LDS  R30,1604
	ORI  R30,0x80
	STS  1604,R30
; 0005 003D 	}
; 0005 003E 	if(usart == &USARTD1){
_0xA0007:
	LDI  R30,LOW(2480)
	LDI  R31,HIGH(2480)
	CALL SUBOPT_0x8
	BRNE _0xA0008
; 0005 003F 		PORTD.DIR &= ~PIN6_bm;				// PORTD_6 Input
	LDS  R30,1632
	ANDI R30,0xBF
	STS  1632,R30
; 0005 0040 		PORTD.DIR |= PIN7_bm;				// PORTD_7 Output
	LDS  R30,1632
	ORI  R30,0x80
	STS  1632,R30
; 0005 0041 		PORTD.OUT |= PIN7_bm;				// PORTD_7 = 1
	LDS  R30,1636
	ORI  R30,0x80
	STS  1636,R30
; 0005 0042 	}
; 0005 0043 	if(usart == &USARTE1){
_0xA0008:
	LDI  R30,LOW(2736)
	LDI  R31,HIGH(2736)
	CALL SUBOPT_0x8
	BRNE _0xA0009
; 0005 0044 		PORTE.DIR &= ~PIN6_bm;				// PORTF_6 Input
	LDS  R30,1664
	ANDI R30,0xBF
	STS  1664,R30
; 0005 0045 		PORTE.DIR |= PIN7_bm;				// PORTE_7 Output
	LDS  R30,1664
	ORI  R30,0x80
	STS  1664,R30
; 0005 0046 		PORTE.OUT |= PIN7_bm;				// PORTE_7 = 1
	LDS  R30,1668
	ORI  R30,0x80
	STS  1668,R30
; 0005 0047 	}
; 0005 0048 	if(usart == &USARTF1){
_0xA0009:
	LDI  R30,LOW(2992)
	LDI  R31,HIGH(2992)
	CALL SUBOPT_0x8
	BRNE _0xA000A
; 0005 0049 		PORTF.DIR &= ~PIN6_bm;				// PORTF_6 Input
	LDS  R30,1696
	ANDI R30,0xBF
	STS  1696,R30
; 0005 004A 		PORTF.DIR |= PIN7_bm;				// PORTF_7 Output
	LDS  R30,1696
	ORI  R30,0x80
	STS  1696,R30
; 0005 004B 		PORTF.OUT |= PIN7_bm;				// PORTF_7 = 1
	LDS  R30,1700
	ORI  R30,0x80
	STS  1700,R30
; 0005 004C 	}
; 0005 004D 	if(sb_mode == 2) stop_c = 0x08;				// 2STOP
_0xA000A:
	LDD  R26,Y+1
	CPI  R26,LOW(0x2)
	BRNE _0xA000B
	LDI  R17,LOW(8)
; 0005 004E 	(usart)->CTRLC = c_mode | p_mode | data_size | stop_c;	// data,parity,char size, 1stop
_0xA000B:
	LDD  R30,Y+2
	LDD  R26,Y+8
	OR   R30,R26
	LDD  R26,Y+3
	OR   R30,R26
	OR   R30,R17
	__PUTB1SNS 9,5
; 0005 004F 
; 0005 0050 // Interrupt set CTRLA
; 0005 0051 // RX : USART_RXCINTLVL_OFF_gc, USART_RXCINTLVL_LO_gc, USART_RXCINTLVL_MED_gc, USART_RXCINTLVL_HI_gc
; 0005 0052 // TX : USART_TXCINTLVL_OFF_gc, USART_TXCINTLVL_LO_gc, USART_TXCINTLVL_MED_gc, USART_TXCINTLVL_HI_gc
; 0005 0053 // Data Register Empty : USART_DREINTLVL_OFF_gc, USART_DREINTLVL_LO_gc, USART_DREINTLVL_MED_gc, USART_DREINTLVL_HI_gc
; 0005 0054 	(usart)->CTRLA = USART_RXCINTLVL_LO_gc | USART_TXCINTLVL_OFF_gc | USART_DREINTLVL_OFF_gc;// RX Lo level Interrupt
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,3
	LDI  R30,LOW(16)
	ST   X,R30
; 0005 0055 // baud rate set
; 0005 0056 // fPer = 32MHz
; 0005 0057 	switch(baud){
	__GETD1S 4
; 0005 0058 		case 300L:
	__CPD1N 0x12C
	BRNE _0xA000F
; 0005 0059 			(usart)->BAUDCTRLA = 0x04;		// BSEL = 3332
	CALL SUBOPT_0x9
; 0005 005A 			(usart)->BAUDCTRLB = (unsigned char)(0x10 | 0x0d);// BSCALE = 1
	LDI  R30,LOW(29)
	ST   X,R30
; 0005 005B 			break;
	RJMP _0xA000E
; 0005 005C 		case 600L:
_0xA000F:
	__CPD1N 0x258
	BRNE _0xA0010
; 0005 005D 			(usart)->BAUDCTRLA = 0x04;		// BSEL = 3332
	CALL SUBOPT_0x9
; 0005 005E 			(usart)->BAUDCTRLB = (unsigned char)(0x00 | 0x0d);// BSCALE = 0
	LDI  R30,LOW(13)
	ST   X,R30
; 0005 005F 			break;
	RJMP _0xA000E
; 0005 0060 		case 1200L:
_0xA0010:
	__CPD1N 0x4B0
	BRNE _0xA0011
; 0005 0061 			(usart)->BAUDCTRLA = 0x04;		// BSEL = 3332
	CALL SUBOPT_0x9
; 0005 0062 			(usart)->BAUDCTRLB = (unsigned char)(0xf0 | 0x0d);// BSCALE = -1
	LDI  R30,LOW(253)
	ST   X,R30
; 0005 0063 			break;
	RJMP _0xA000E
; 0005 0064 		case 2400L:
_0xA0011:
	__CPD1N 0x960
	BRNE _0xA0012
; 0005 0065 			(usart)->BAUDCTRLA = 0x01;		// BSEL = 3329
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,6
	LDI  R30,LOW(1)
	CALL SUBOPT_0xA
; 0005 0066 			(usart)->BAUDCTRLB = (unsigned char)(0xe0 | 0x0d);// BSCALE = -2
	LDI  R30,LOW(237)
	ST   X,R30
; 0005 0067 			break;
	RJMP _0xA000E
; 0005 0068 		case 4800L:
_0xA0012:
	__CPD1N 0x12C0
	BRNE _0xA0013
; 0005 0069 			(usart)->BAUDCTRLA = 0xfd;		// BSEL = 3325
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,6
	LDI  R30,LOW(253)
	CALL SUBOPT_0xA
; 0005 006A 			(usart)->BAUDCTRLB = (unsigned char)(0xd0 | 0x0c);// BSCALE = -3
	LDI  R30,LOW(220)
	ST   X,R30
; 0005 006B 			break;
	RJMP _0xA000E
; 0005 006C 		case 9600L:
_0xA0013:
	__CPD1N 0x2580
	BRNE _0xA0014
; 0005 006D 			(usart)->BAUDCTRLA = 0xf5;		// BSEL = 3317
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,6
	LDI  R30,LOW(245)
	CALL SUBOPT_0xA
; 0005 006E 			(usart)->BAUDCTRLB = (unsigned char)(0xc0 | 0x0c);// BSCALE = -4
	LDI  R30,LOW(204)
	ST   X,R30
; 0005 006F 			break;
	RJMP _0xA000E
; 0005 0070 		case 19200L:
_0xA0014:
	__CPD1N 0x4B00
	BRNE _0xA0015
; 0005 0071 			(usart)->BAUDCTRLA = 0xe5;		// BSEL = 3301
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,6
	LDI  R30,LOW(229)
	CALL SUBOPT_0xA
; 0005 0072 			(usart)->BAUDCTRLB = (unsigned char)(0xB0 | 0x0C);// BSCALE = -5
	LDI  R30,LOW(188)
	ST   X,R30
; 0005 0073 			break;
	RJMP _0xA000E
; 0005 0074 		case 38400L:
_0xA0015:
	__CPD1N 0x9600
	BRNE _0xA0016
; 0005 0075 			(usart)->BAUDCTRLA = 0xc5;		// BSEL = 3269
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,6
	LDI  R30,LOW(197)
	CALL SUBOPT_0xA
; 0005 0076 			(usart)->BAUDCTRLB = (unsigned char)(0xa0 | 0x0C);// BSCALE = -6
	LDI  R30,LOW(172)
	ST   X,R30
; 0005 0077 			break;
	RJMP _0xA000E
; 0005 0078 		case 57600L:
_0xA0016:
	__CPD1N 0xE100
	BRNE _0xA0017
; 0005 0079 			(usart)->BAUDCTRLA = 0x6e;		// BSEL = 2158
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,6
	LDI  R30,LOW(110)
	CALL SUBOPT_0xA
; 0005 007A 			(usart)->BAUDCTRLB = (unsigned char)(0xa0 | 0x08);// BSCALE = -6
	LDI  R30,LOW(168)
	ST   X,R30
; 0005 007B 			break;
	RJMP _0xA000E
; 0005 007C 		case 115200L:
_0xA0017:
	__CPD1N 0x1C200
	BRNE _0xA0019
; 0005 007D 			(usart)->BAUDCTRLA = 0x2e;		// BSEL = 2094
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,6
	LDI  R30,LOW(46)
	CALL SUBOPT_0xA
; 0005 007E 			(usart)->BAUDCTRLB = (unsigned char)(0x90 | 0x08);// BSCALE = -7
	LDI  R30,LOW(152)
	ST   X,R30
; 0005 007F 			break;
; 0005 0080 		default: break;
_0xA0019:
; 0005 0081 	}
_0xA000E:
; 0005 0082 	(usart)->CTRLB = USART_RXEN_bm | USART_TXEN_bm;		// Receiver, Transmitter Enable
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,4
	LDI  R30,LOW(24)
	ST   X,R30
; 0005 0083 }
	LDD  R17,Y+0
	ADIW R28,11
	RET
;
;// ============================== COM1 1Ʈ ۽ =========================
;// [μ] char data
;// item1:  
;// [] USARTC0
;// --------------------------------------------------------------------------
;int putchar_1(char data)
; 0005 008B {
; 0005 008C 	while((USARTC0.STATUS & USART_DREIF_bm) == 0);		// UARTC0 ۽ 
;	data -> Y+0
; 0005 008D 	USARTC0.DATA = data;
; 0005 008E 	return(0);
; 0005 008F }
;
;// ============================== COM1 1Ʈ  =========================
;// [μ] void
;// []  
;// [] USARTC0
;// --------------------------------------------------------------------------
;int getchar_1(void)
; 0005 0097 {
; 0005 0098 	while ((USARTC0.STATUS & USART_RXCIF_bm) == 0);		// UARTFC0  
; 0005 0099 	return(USARTC0.DATA);
; 0005 009A }
;
;// ============================== COM2 1Ʈ ۽ =========================
;// [μ] char data
;// item1:  
;// [] USARTC1
;// --------------------------------------------------------------------------
;int putchar_2(char data)
; 0005 00A2 {
; 0005 00A3 	while((USARTC1.STATUS & USART_DREIF_bm) == 0);		// UARTC1 ۽ 
;	data -> Y+0
; 0005 00A4 	USARTC1.DATA = data;
; 0005 00A5 	return(0);
; 0005 00A6 }
;
;// ============================== COM2 1Ʈ  =========================
;// [μ] void
;// []  
;// [] USARTC1
;// --------------------------------------------------------------------------
;int getchar_2(void)
; 0005 00AE {
; 0005 00AF 	while((USARTC1.STATUS & USART_RXCIF_bm) == 0);		// UARTC1  
; 0005 00B0 	return(USARTC1.DATA);
; 0005 00B1 }
;
;// ============================== COM3 1Ʈ ۽ =========================
;// [μ] char data
;// item1:  
;// [] USARTD0
;// --------------------------------------------------------------------------
;int putchar_3(char data)
; 0005 00B9 {
; 0005 00BA 	while((USARTD0.STATUS & USART_DREIF_bm) == 0);		// UARTD0 ۽ 
;	data -> Y+0
; 0005 00BB 	USARTD0.DATA = data;
; 0005 00BC 	return(0);
; 0005 00BD }
;
;// ============================== COM3 1Ʈ  =========================
;// [μ] void
;// []  
;// [] USARTD0
;// --------------------------------------------------------------------------
;int getchar_3(void)
; 0005 00C5 {
; 0005 00C6 	while((USARTD0.STATUS & USART_RXCIF_bm) == 0);		// UARTD0  
; 0005 00C7 	return(USARTD0.DATA);
; 0005 00C8 }
;
;// ============================== COM4 1Ʈ ۽ =========================
;// [μ] char data
;// item1:  
;// [] USARTD1
;// --------------------------------------------------------------------------
;int putchar_4(char data)
; 0005 00D0 {
; 0005 00D1 	while((USARTD1.STATUS & USART_DREIF_bm) == 0);		// UARTD1 ۽ 
;	data -> Y+0
; 0005 00D2 	USARTD1.DATA = data;
; 0005 00D3 	return(0);
; 0005 00D4 }
;
;// ============================== COM4 1Ʈ  =========================
;// [μ] void
;// []  
;// [] USARTD1
;// --------------------------------------------------------------------------
;int getchar_4(void)
; 0005 00DC {
; 0005 00DD 	while((USARTD1.STATUS & USART_RXCIF_bm) == 0);		// UARTD1  
; 0005 00DE 	return(USARTD1.DATA);
; 0005 00DF }
;
;// ============================== COM5 1Ʈ ۽ =========================
;// [μ] char data
;// item1:  
;// [] USARTE0
;// --------------------------------------------------------------------------
;int putchar_5(char data)
; 0005 00E7 {
; 0005 00E8 	while((USARTE0.STATUS & USART_DREIF_bm) == 0);		// UARTE0 ۽ 
;	data -> Y+0
; 0005 00E9 	USARTE0.DATA = data;
; 0005 00EA 	return(0);
; 0005 00EB }
;
;// ============================== COM5 1Ʈ  =========================
;// [μ] void
;// []  
;// [] USARTE0
;// --------------------------------------------------------------------------
;int getchar_5(void)
; 0005 00F3 {
; 0005 00F4 	while((USARTE0.STATUS & USART_RXCIF_bm) == 0);		// UARTE0  
; 0005 00F5 	return(USARTE0.DATA);
; 0005 00F6 }
;
;// ============================== COM6 1Ʈ ۽ =========================
;// [μ] char data
;// item1:  
;// [] USARTE1
;// --------------------------------------------------------------------------
;int putchar_6(char data)
; 0005 00FE {
; 0005 00FF 	while((USARTE1.STATUS & USART_DREIF_bm) == 0);		// UARTE1 ۽ 
;	data -> Y+0
; 0005 0100 	USARTE1.DATA = data;
; 0005 0101 	return(0);
; 0005 0102 }
;
;// ============================== COM6 1Ʈ  =========================
;// [μ] void
;// []  
;// [] USARTE1
;// --------------------------------------------------------------------------
;int getchar_6(void)
; 0005 010A {
; 0005 010B 	while((USARTE1.STATUS & USART_RXCIF_bm) == 0);		// UARTE1  
; 0005 010C 	return(USARTE1.DATA);
; 0005 010D }
;
;// ============================== COM7 1Ʈ ۽ =========================
;// [μ] char data
;// item1:  
;// [] USARTF0
;// --------------------------------------------------------------------------
;int putchar_7(char data)
; 0005 0115 {
; 0005 0116 	while((USARTF0.STATUS & USART_DREIF_bm) == 0);		// UARTF0 ۽ 
;	data -> Y+0
; 0005 0117 	USARTF0.DATA = data;
; 0005 0118 	return(0);
; 0005 0119 }
;
;// ============================== COM7 1Ʈ  =========================
;// [μ] void
;// []  
;// [] USARTF0
;// --------------------------------------------------------------------------
;int getchar_7(void)
; 0005 0121 {
; 0005 0122 	while((USARTF0.STATUS & USART_RXCIF_bm) == 0);		// UARTF0  
; 0005 0123 	return(USARTF0.DATA);
; 0005 0124 }
;
;// ============================== COM8 1Ʈ ۽ =========================
;// [μ] char data
;// item1:  
;// [] USARTF1
;// --------------------------------------------------------------------------
;int putchar_8(char data)
; 0005 012C {
_putchar_8:
; 0005 012D 	while((USARTF1.STATUS & USART_DREIF_bm) == 0);		// UARTF1 ۽ 
;	data -> Y+0
_0xA0044:
	LDS  R30,2993
	ANDI R30,LOW(0x20)
	BREQ _0xA0044
; 0005 012E 	USARTF1.DATA = data;
	LD   R30,Y
	STS  2992,R30
; 0005 012F 	return(0);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x20A0002
; 0005 0130 }
;
;// ============================== COM8 1Ʈ  =========================
;// [μ] void
;// []  
;// [] USARTF1
;// --------------------------------------------------------------------------
;int getchar_8(void)
; 0005 0138 {
; 0005 0139 	while((USARTF1.STATUS & USART_RXCIF_bm) == 0);		// UARTF1  
; 0005 013A 	return(USARTF1.DATA);
; 0005 013B }
;
;// ============================== COM7 printf  ======================
;// [μ] char c
;// item1:  
;// [] USARTF0
;// --------------------------------------------------------------------------
;void putchar(char c)
; 0005 0143 {
_putchar:
; 0005 0144 	while((USARTF0.STATUS & USART_DREIF_bm) == 0);		// UARTF0 ۽ 
;	c -> Y+0
_0xA004A:
	LDS  R30,2977
	ANDI R30,LOW(0x20)
	BREQ _0xA004A
; 0005 0145 	USARTF0.DATA = c;
	LD   R30,Y
	STS  2976,R30
; 0005 0146 }
_0x20A0002:
	ADIW R28,1
	RET

	.CSEG
_put_usart_G100:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0xB
	ADIW R28,3
	RET
_put_buff_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000013
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000015
	__CPWRN 16,17,2
	BRLO _0x2000016
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000015:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0xB
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000017
	CALL SUBOPT_0xB
_0x2000017:
_0x2000016:
	RJMP _0x2000018
_0x2000013:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000018:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G100:
	SBIW R28,11
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000019:
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ADIW R30,1
	STD  Y+23,R30
	STD  Y+23+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x200001B
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	LDI  R17,LOW(1)
	RJMP _0x2000021
_0x2000020:
	CALL SUBOPT_0xC
_0x2000021:
	RJMP _0x200001E
_0x200001F:
	CPI  R30,LOW(0x1)
	BRNE _0x2000022
	CPI  R18,37
	BRNE _0x2000023
	CALL SUBOPT_0xC
	RJMP _0x20000D5
_0x2000023:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000024
	LDI  R16,LOW(1)
	RJMP _0x200001E
_0x2000024:
	CPI  R18,43
	BRNE _0x2000025
	LDI  R20,LOW(43)
	RJMP _0x200001E
_0x2000025:
	CPI  R18,32
	BRNE _0x2000026
	LDI  R20,LOW(32)
	RJMP _0x200001E
_0x2000026:
	RJMP _0x2000027
_0x2000022:
	CPI  R30,LOW(0x2)
	BRNE _0x2000028
_0x2000027:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000029
	ORI  R16,LOW(128)
	RJMP _0x200001E
_0x2000029:
	RJMP _0x200002A
_0x2000028:
	CPI  R30,LOW(0x3)
	BRNE _0x200002B
_0x200002A:
	CPI  R18,48
	BRLO _0x200002D
	CPI  R18,58
	BRLO _0x200002E
_0x200002D:
	RJMP _0x200002C
_0x200002E:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001E
_0x200002C:
	CPI  R18,108
	BRNE _0x200002F
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x200001E
_0x200002F:
	RJMP _0x2000030
_0x200002B:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x200001E
_0x2000030:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2000035
	CALL SUBOPT_0xD
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0xE
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x73)
	BRNE _0x2000038
	CALL SUBOPT_0xD
	CALL SUBOPT_0xF
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000039
_0x2000038:
	CPI  R30,LOW(0x70)
	BRNE _0x200003B
	CALL SUBOPT_0xD
	CALL SUBOPT_0xF
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000039:
	ANDI R16,LOW(127)
	LDI  R30,LOW(0)
	STD  Y+16,R30
	LDI  R19,LOW(0)
	RJMP _0x200003C
_0x200003B:
	CPI  R30,LOW(0x64)
	BREQ _0x200003F
	CPI  R30,LOW(0x69)
	BRNE _0x2000040
_0x200003F:
	ORI  R16,LOW(4)
	RJMP _0x2000041
_0x2000040:
	CPI  R30,LOW(0x75)
	BRNE _0x2000042
_0x2000041:
	LDI  R30,LOW(10)
	STD  Y+16,R30
	SBRS R16,1
	RJMP _0x2000043
	__GETD1N 0x3B9ACA00
	CALL SUBOPT_0x10
	LDI  R17,LOW(10)
	RJMP _0x2000044
_0x2000043:
	__GETD1N 0x2710
	CALL SUBOPT_0x10
	LDI  R17,LOW(5)
	RJMP _0x2000044
_0x2000042:
	CPI  R30,LOW(0x58)
	BRNE _0x2000046
	ORI  R16,LOW(8)
	RJMP _0x2000047
_0x2000046:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x200007A
_0x2000047:
	LDI  R30,LOW(16)
	STD  Y+16,R30
	SBRS R16,1
	RJMP _0x2000049
	__GETD1N 0x10000000
	CALL SUBOPT_0x10
	LDI  R17,LOW(8)
	RJMP _0x2000044
_0x2000049:
	__GETD1N 0x1000
	CALL SUBOPT_0x10
	LDI  R17,LOW(4)
_0x2000044:
	SBRS R16,1
	RJMP _0x200004A
	CALL SUBOPT_0xD
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETD1P
	RJMP _0x20000D6
_0x200004A:
	SBRS R16,2
	RJMP _0x200004C
	CALL SUBOPT_0xD
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	CALL __CWD1
	RJMP _0x20000D6
_0x200004C:
	CALL SUBOPT_0xD
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	CLR  R22
	CLR  R23
_0x20000D6:
	__PUTD1S 12
	SBRS R16,2
	RJMP _0x200004E
	LDD  R26,Y+15
	TST  R26
	BRPL _0x200004F
	__GETD1S 12
	CALL __ANEGD1
	__PUTD1S 12
	LDI  R20,LOW(45)
_0x200004F:
	CPI  R20,0
	BREQ _0x2000050
	SUBI R17,-LOW(1)
	RJMP _0x2000051
_0x2000050:
	ANDI R16,LOW(251)
_0x2000051:
_0x200004E:
_0x200003C:
	SBRC R16,0
	RJMP _0x2000052
_0x2000053:
	CP   R17,R21
	BRSH _0x2000055
	SBRS R16,7
	RJMP _0x2000056
	SBRS R16,2
	RJMP _0x2000057
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x2000058
_0x2000057:
	LDI  R18,LOW(48)
_0x2000058:
	RJMP _0x2000059
_0x2000056:
	LDI  R18,LOW(32)
_0x2000059:
	CALL SUBOPT_0xC
	SUBI R21,LOW(1)
	RJMP _0x2000053
_0x2000055:
_0x2000052:
	MOV  R19,R17
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0x200005A
_0x200005B:
	CPI  R19,0
	BREQ _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x200005F
_0x200005E:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x200005F:
	CALL SUBOPT_0xC
	CPI  R21,0
	BREQ _0x2000060
	SUBI R21,LOW(1)
_0x2000060:
	SUBI R19,LOW(1)
	RJMP _0x200005B
_0x200005D:
	RJMP _0x2000061
_0x200005A:
_0x2000063:
	CALL SUBOPT_0x11
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x2000065
	SBRS R16,3
	RJMP _0x2000066
	SUBI R18,-LOW(55)
	RJMP _0x2000067
_0x2000066:
	SUBI R18,-LOW(87)
_0x2000067:
	RJMP _0x2000068
_0x2000065:
	SUBI R18,-LOW(48)
_0x2000068:
	SBRC R16,4
	RJMP _0x200006A
	CPI  R18,49
	BRSH _0x200006C
	__GETD2S 8
	__CPD2N 0x1
	BRNE _0x200006B
_0x200006C:
	RJMP _0x200006E
_0x200006B:
	CP   R21,R19
	BRLO _0x2000070
	SBRS R16,0
	RJMP _0x2000071
_0x2000070:
	RJMP _0x200006F
_0x2000071:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000072
	LDI  R18,LOW(48)
_0x200006E:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2000073
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0xE
	CPI  R21,0
	BREQ _0x2000074
	SUBI R21,LOW(1)
_0x2000074:
_0x2000073:
_0x2000072:
_0x200006A:
	CALL SUBOPT_0xC
	CPI  R21,0
	BREQ _0x2000075
	SUBI R21,LOW(1)
_0x2000075:
_0x200006F:
	SUBI R19,LOW(1)
	CALL SUBOPT_0x11
	CALL __MODD21U
	__PUTD1S 12
	LDD  R30,Y+16
	__GETD2S 8
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	CALL SUBOPT_0x10
	__GETD1S 8
	CALL __CPD10
	BREQ _0x2000064
	RJMP _0x2000063
_0x2000064:
_0x2000061:
	SBRS R16,0
	RJMP _0x2000076
_0x2000077:
	CPI  R21,0
	BREQ _0x2000079
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0xE
	RJMP _0x2000077
_0x2000079:
_0x2000076:
_0x200007A:
_0x2000036:
_0x20000D5:
	LDI  R17,LOW(0)
_0x200001E:
	RJMP _0x2000019
_0x200001B:
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,25
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x12
	SBIW R30,0
	BRNE _0x200007B
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20A0001
_0x200007B:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x12
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x13
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20A0001:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
	STD  Y+6,R30
	STD  Y+6+1,R30
	MOVW R26,R28
	ADIW R26,8
	CALL SUBOPT_0x13
	LDI  R30,LOW(_put_usart_G100)
	LDI  R31,HIGH(_put_usart_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,8
	POP  R15
	RET

	.CSEG

	.DSEG

	.CSEG

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG

	.DSEG
_com8_rx_data:
	.BYTE 0x32
_tx_cnt:
	.BYTE 0x2
__seed_G101:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(64285)
	LDI  R31,HIGH(64285)
	STS  2080,R30
	STS  2080+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	CALL __PUTPARD1
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _Com_Init

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
	SBIW R30,1
	SUBI R30,LOW(-_com8_rx_data)
	SBCI R31,HIGH(-_com8_rx_data)
	ST   Z,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x80000,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4:
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x5:
	MOVW R30,R16
	__ADDWRN 16,17,1
	MOVW R26,R28
	ADIW R26,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+56
	STD  Z+0,R26
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+57
	STD  Z+0,R26
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x8:
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x9:
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,6
	LDI  R30,LOW(4)
	ST   X,R30
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xA:
	ST   X,R30
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0xC:
	ST   -Y,R18
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xD:
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	SBIW R30,4
	STD  Y+21,R30
	STD  Y+21+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xE:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF:
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	__GETD1S 8
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET


	.CSEG
__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
