// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ͷƮ  ƾ
// ----------------------------------------------------------------------------
//   

// Լ 

//  
char com7_rx_data,com7_rx_eflg = 0;				// COM7   ͷƮ  /÷
char com8_rx_data[50],com8_rx_eflg = 0;				// COM8   ͷƮ  /÷
int com8_rx_usi = 0,com8_rx_udi = 0;				// COM8   

int timer0_base_cnt = 0;					// Ÿ̸0 ͷƮ  ī
int timer0_tx_cnt = 0;						// Ÿ̸0 ſ ī

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned char uch;
	
	cli();							// ͷƮ 

// system clock setup
	// external oscillator initialization
	OSC.XOSCCTRL = OSC_FRQRANGE_12TO16_gc | OSC_XOSCSEL_XTAL_16KCLK_gc;// XTAL 8MHz, 16K CLK startup time
	OSC.CTRL = OSC_XOSCEN_bm;				// external oscillator enable
	while((OSC.STATUS & OSC_XOSCRDY_bm) == 0);		// external clock source ready

	// PLL initialization
	uch = OSC_PLLSRC_XOSC_gc | 4;				// PLL clock source XTAL, multiplication factor = 4(8MHz*4 = 32MHz)
	CCP = CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	OSC.PLLCTRL = uch;
	OSC.CTRL |= OSC_PLLEN_bm;				// Enable the PLL

	// System clock prescalers A,B,C set
	// clkPer4: 32MHz
	// clkPer2: 32MHz
	// clkPer : 32MHz
	// clkCPU : 32MHz
	uch = CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;		// prescaler division factor(A=1, B=1, C=1)
	CCP = CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	CLK.PSCTRL = uch;
	while((OSC.STATUS & OSC_PLLRDY_bm) == 0);		// PLL ready

	// select the system clock source
	uch = CLK_SCLKSEL_PLL_gc;				// Select the system clock source: Phase Locked Loop
	CCP=CCP_IOREG_gc;					// write to configuration change protection register(IO register)
	CLK.CTRL = uch;

// portc_7 system clock output
//	PORTCFG.CLKEVOUT = PORTCFG_CLKOUT_PC7_gc;		// poetc_7 bit clock output
//	PORTC.DIRSET |= 0x80;

// PORTF XBee   ʱȭ
// PORTF.4(OUT) : RST\(L:,H:Reset)
// PORTF.5(OUT) : Sleep( L)
	PORTF.OUT = 0x10;
	PORTF.DIRSET = 0x30;

// Timer/Counter TCC0 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCC0.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCC0.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCC0.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCC0.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCC0.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc | TC_CCCINTLVL_OFF_gc | TC_CCDINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCC0.INTFLAGS ^= TCC0.INTFLAGS;				// Clear the interrupt flags

	TCC0.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCC0.PER = 0x0000;					// Set period register
	TCC0.CCA = 0x0000;					// Compare,Capture register
	TCC0.CCB = 0x0000;
	TCC0.CCC = 0x0000;
	TCC0.CCD = 0x0000;

// USART 
//	Com_Init(&USARTC0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM1(PORTC0) ASYNC,19200,8,N,1 
//	Com_Init(&USARTC1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM2(PORTC1) ASYNC,19200,8,N,1 
//	Com_Init(&USARTD0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM3(PORTD0) ASYNC,19200,8,N,1 
//	Com_Init(&USARTD1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM4(PORTD1) ASYNC,19200,8,N,1 
//	Com_Init(&USARTE0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM5(PORTE0) ASYNC,19200,8,N,1 
//	Com_Init(&USARTE1, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM6(PORTE1) ASYNC,19200,8,N,1 
	Com_Init(&USARTF0, USART_CMODE_ASYNCHRONOUS_gc, 19200L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM7(PORTF0) ASYNC,19200,8,N,1 
	Com_Init(&USARTF1, USART_CMODE_ASYNCHRONOUS_gc,  9600L, USART_CHSIZE_8BIT_gc, USART_PMODE_DISABLED_gc, 1);// COM8(PORTF1) ASYNC, 9600,8,N,1 

	fdevopen(putchar_7,getchar_7,0);			// COM7(USARTF0) printf() 

	PMIC.CTRL |= PMIC_LOLVLEX_bm;				// Enable PMIC interrupt level low.(PMIC_LOLVLEX_bm, PMIC_MEDLVLEX_bm, PMIC_HILVLEX_bm)
	sei();							// ͷƮ 㰡
}

// =========================== USARTF0  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(USARTF0_RXC_vect)
{
unsigned char status, data;

	status = USARTF0.STATUS;				//   
	data = USARTF0.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		com7_rx_data = data;				//  
		com7_rx_eflg = 1;				//  Ϸ flag set
	}
}

// =========================== USARTF1  ͷƮ ==========================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(USARTF1_RXC_vect)
{
unsigned char status, data;

	status = USARTF1.STATUS;				//   
	data = USARTF1.DATA;					//   
	if((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0){//   ˻ 
		if(com8_rx_eflg == 0){				//    ó ƴҶ
			if(data == STX){			//  ڵ ã
				com8_rx_usi = 0;		//   Ŭ
				com8_rx_data[com8_rx_usi++] = data;// STX 
			}
			else if(data == ETX){			//  ڵ ã
				com8_rx_data[com8_rx_usi++] = data;// ETX 
				com8_rx_data[com8_rx_usi] = 0;	// NULL  
				com8_rx_udi = com8_rx_usi;	//   ( ó )
				com8_rx_eflg = 1;		//  Ϸ ÷ ON( ó )
				com8_rx_usi = 0;		//   Ŭ
			}
			else{
				com8_rx_data[com8_rx_usi++] = data;//  
				if(com8_rx_usi >= 45) com8_rx_usi = 0;//  ʰ ˻			
			}
		}
	}
}

// ============================ TCC0 overflow ͷƮ ========================
// [μ] void
// [] 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
// ----------------------------------------------------------------------------
SIGNAL(TCC0_OVF_vect)
{
	TCC0.CNT = 64285;					// 65535-1250 = 64285
	timer0_base_cnt++;					// Ÿ̸0 ⺻   ī 10ms
	timer0_tx_cnt++;					// Ÿ̸0 ſ ī 10ms
}
